#define MUIMASTER_YES_INLINE_STDARG

#include <proto/muimaster.h>
#include <proto/intuition.h>
#include <proto/alib.h>

#include <libraries/mui.h>

#include <stdio.h>
#include <stdlib.h>

#include "class3.h"

static VOID fail(APTR app, char *str)
{
    if (app)
        MUI_DisposeObject(app);

    if (str)
    {
        puts(str);
        exit(20);
    }
    exit(0);
}

int main(void)
{
    Object *app, *window, *MyObj;

    app = ApplicationObject,
        MUIA_Application_Title      , (IPTR)"Class3",
        MUIA_Application_Version    , (IPTR)"$VER: Class3 20.0 (17.08.2012)",
        MUIA_Application_Copyright  , (IPTR)"2012, The AROS Development Team",
        MUIA_Application_Author     , (IPTR)"The AROS Development Team",
        MUIA_Application_Description, (IPTR)"Custom class generated by ChocolateCastle.",
        MUIA_Application_Base       , (IPTR)"CLASS3",

        SubWindow, (IPTR)(window = WindowObject,
            MUIA_Window_Title, (IPTR)"A rather complex custom class",
            MUIA_Window_ID   , MAKE_ID('C','L','S','3'),
            WindowContents, (IPTR)(VGroup,
                Child, (IPTR)(TextObject,
                    TextFrame,
                    MUIA_Background, MUII_TextBack,
                    MUIA_Text_Contents, (IPTR)"\33cPaint with mouse,\nscroll with cursor keys.",
                End),
                Child, (IPTR)(MyObj = Class3Object,
                    TextFrame,
                End),
            End),
        End),
    End;

    if (!app)
        fail(app,"Failed to create Application.");

    set(window, MUIA_Window_DefaultObject, MyObj);

    DoMethod(window, MUIM_Notify, MUIA_Window_CloseRequest, TRUE,
        app, 2, MUIM_Application_ReturnID, MUIV_Application_ReturnID_Quit);

    set(window, MUIA_Window_Open, TRUE);

    DoMethod(app, MUIM_Application_Execute);

    set(window, MUIA_Window_Open, FALSE);

    fail(app, NULL);

    return 0;
}
