/***************************************************************************

  MUIBuilder - MUI interface builder
  Copyright (C) 1990-2009 by Eric Totel
  Copyright (C) 2010-2011 by MUIBuilder Open Source Team

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.

  MUIBuilder Support Site: http://sourceforge.net/projects/muibuilder/

  $Id$$

***************************************************************************/

#ifndef MUIB_FILE_H
#define MUIB_FILE_H

#define MB_LIBRARIES_MUI_H 0
#define MB_MUIMASTER_NAME 1
#define MB_MUIMASTER_VMIN 2
#define MB_MC_TEMPLATE_ID 3
#define MB_MUI_RXERR_BADDEFINITION 4
#define MB_MUI_RXERR_OUTOFMEMORY 5
#define MB_MUI_RXERR_UNKNOWNCOMMAND 6
#define MB_MUI_RXERR_BADSYNTAX 7
#define MB_MUIE_OK 8
#define MB_MUIE_OutOfMemory 9
#define MB_MUIE_OutOfGfxMemory 10
#define MB_MUIE_InvalidWindowObject 11
#define MB_MUIE_MissingLibrary 12
#define MB_MUIE_NoARexx 13
#define MB_MUIE_SingleTask 14
#define MB_MUII_WindowBack 15
#define MB_MUII_RequesterBack 16
#define MB_MUII_ButtonBack 17
#define MB_MUII_ListBack 18
#define MB_MUII_TextBack 19
#define MB_MUII_PropBack 20
#define MB_MUII_ActiveBack 21
#define MB_MUII_SelectedBack 22
#define MB_MUII_ListCursor 23
#define MB_MUII_ListSelect 24
#define MB_MUII_ListSelCur 25
#define MB_MUII_ArrowUp 26
#define MB_MUII_ArrowDown 27
#define MB_MUII_ArrowLeft 28
#define MB_MUII_ArrowRight 29
#define MB_MUII_CheckMark 30
#define MB_MUII_RadioButton 31
#define MB_MUII_Cycle 32
#define MB_MUII_PopUp 33
#define MB_MUII_PopFile 34
#define MB_MUII_PopDrawer 35
#define MB_MUII_PropKnob 36
#define MB_MUII_Drawer 37
#define MB_MUII_HardDisk 38
#define MB_MUII_Disk 39
#define MB_MUII_Chip 40
#define MB_MUII_Volume 41
#define MB_MUII_PopUpBack 42
#define MB_MUII_Network 43
#define MB_MUII_Assign 44
#define MB_MUII_TapePlay 45
#define MB_MUII_TapePlayBack 46
#define MB_MUII_TapePause 47
#define MB_MUII_TapeStop 48
#define MB_MUII_TapeRecord 49
#define MB_MUII_GroupBack 50
#define MB_MUII_SliderBack 51
#define MB_MUII_SliderKnob 52
#define MB_MUII_TapeUp 53
#define MB_MUII_TapeDown 54
#define MB_MUII_Count 55
#define MB_MUII_BACKGROUND 56
#define MB_MUII_SHADOW 57
#define MB_MUII_SHINE 58
#define MB_MUII_FILL 59
#define MB_MUII_SHADOWBACK 60
#define MB_MUII_SHADOWFILL 61
#define MB_MUII_SHADOWSHINE 62
#define MB_MUII_FILLBACK 63
#define MB_MUII_FILLSHINE 64
#define MB_MUII_SHINEBACK 65
#define MB_MUII_FILLBACK2 66
#define MB_MUII_HSHINEBACK 67
#define MB_MUII_HSHADOWBACK 68
#define MB_MUII_HSHINESHINE 69
#define MB_MUII_HSHADOWSHADOW 70
#define MB_MUII_N1HSHINE 71
#define MB_MUII_LASTPAT 72
#define MB_MUIV_TriggerValue 73
#define MB_MUIV_EveryTime 74
#define MB_MUIV_Application_Save_ENV 75
#define MB_MUIV_Application_Save_ENVARC 76
#define MB_MUIV_Application_Load_ENV 77
#define MB_MUIV_Application_Load_ENVARC 78
#define MB_MUIV_Application_ReturnID_Quit 79
#define MB_MUIV_List_Insert_Top 80
#define MB_MUIV_List_Insert_Active 81
#define MB_MUIV_List_Insert_Sorted 82
#define MB_MUIV_List_Insert_Bottom 83
#define MB_MUIV_List_Remove_First 84
#define MB_MUIV_List_Remove_Active 85
#define MB_MUIV_List_Remove_Last 86
#define MB_MUIV_List_Select_Off 87
#define MB_MUIV_List_Select_On 88
#define MB_MUIV_List_Select_Toggle 89
#define MB_MUIV_List_Select_Ask 90
#define MB_MUIV_List_Jump_Active 91
#define MB_MUIV_List_GetEntry_Active 92
#define MB_MUIV_List_Select_Active 93
#define MB_MUIV_List_Select_All 94
#define MB_MUIV_List_Redraw_Active 95
#define MB_MUIV_List_Redraw_All 96
#define MB_MUIV_List_Exchange_Active 97
#define MB_MUIV_Colorpanel_GetColor_Active 98
#define MB_MUIV_Colorpanel_SetColor_Active 99
#define MB_MUIX_R 100
#define MB_MUIX_C 101
#define MB_MUIX_L 102
#define MB_MUIX_N 103
#define MB_MUIX_B 104
#define MB_MUIX_I 105
#define MB_MUIX_U 106
#define MB_MUIX_PT 107
#define MB_MUIX_PH 108
#define MB_MUIV_Palette_Entry_End 109
#define MB_WindowObject 110
#define MB_ImageObject 111
#define MB_NotifyObject 112
#define MB_ApplicationObject 113
#define MB_TextObject 114
#define MB_RectangleObject 115
#define MB_ListObject 116
#define MB_PropObject 117
#define MB_StringObject 118
#define MB_ScrollbarObject 119
#define MB_ListviewObject 120
#define MB_RadioObject 121
#define MB_VolumelistObject 122
#define MB_FloattextObject 123
#define MB_DirlistObject 124
#define MB_SliderObject 125
#define MB_CycleObject 126
#define MB_GaugeObject 127
#define MB_ScaleObject 128
#define MB_BoopsiObject 129
#define MB_ColorfieldObject 130
#define MB_ColorpanelObject 131
#define MB_ColoradjustObject 132
#define MB_PaletteObject 133
#define MB_GroupObject 134
#define MB_RegisterObject 135
#define MB_VirtgroupObject 136
#define MB_ScrollgroupObject 137
#define MB_PopstringObject 138
#define MB_PopobjectObject 139
#define MB_PopaslObject 140
#define MB_ScrmodelistObject 141
#define MB_VGroup 142
#define MB_HGroup 143
#define MB_ColGroup 144
#define MB_RowGroup 145
#define MB_PageGroup 146
#define MB_VGroupV 147
#define MB_HGroupV 148
#define MB_ColGroupV 149
#define MB_RowGroupV 150
#define MB_PageGroupV 151
#define MB_RegisterGroup 152
#define MB_End 153
#define MB_Child 154
#define MB_SubWindow 155
#define MB_WindowContents 156
#define MB_NoFrame 157
#define MB_ButtonFrame 158
#define MB_ImageButtonFrame 159
#define MB_TextFrame 160
#define MB_StringFrame 161
#define MB_ReadListFrame 162
#define MB_InputListFrame 163
#define MB_PropFrame 164
#define MB_SliderFrame 165
#define MB_GaugeFrame 166
#define MB_VirtualFrame 167
#define MB_GroupFrame 168
#define MB_GroupFrameT 169
#define MB_HVSpace 170
#define MB_HSpace 171
#define MB_VSpace 172
#define MB_HCenter 173
#define MB_VCenter 174
#define MB_InnerSpacing 175
#define MB_GroupSpacing 176
#define MB_String 177
#define MB_KeyString 178
#define MB_CheckMark 179
#define MB_KeyCheckMark 180
#define MB_SimpleButton 181
#define MB_KeyButton 182
#define MB_Cycle 183
#define MB_KeyCycle 184
#define MB_Radio 185
#define MB_KeyRadio 186
#define MB_Slider 187
#define MB_KeySlider 188
#define MB_PopButton 189
#define MB_Label 190
#define MB_Label1 191
#define MB_Label2 192
#define MB_LLabel 193
#define MB_LLabel1 194
#define MB_LLabel2 195
#define MB_KeyLabel 196
#define MB_KeyLabel1 197
#define MB_KeyLabel2 198
#define MB_KeyLLabel 199
#define MB_KeyLLabel1 200
#define MB_KeyLLabel2 201
#define MB_get 202
#define MB_set 203
#define MB_nnset 204
#define MB_setmutex 205
#define MB_setcycle 206
#define MB_setstring 207
#define MB_setcheckmark 208
#define MB_setslider 209
#define MB_MUIM_BoopsiQuery 210
#define MB_MUIP_BoopsiQuery 211
#define MB_MBQF_HORIZ 212
#define MB_MBQ_MUI_MAXMAX 213
#define MB_MUIC_Notify 214
#define MB_MUIM_CallHook 215
#define MB_MUIM_KillNotify 216
#define MB_MUIM_MultiSet 217
#define MB_MUIM_Notify 218
#define MB_MUIM_Set 219
#define MB_MUIM_SetAsString 220
#define MB_MUIM_WriteLong 221
#define MB_MUIM_WriteString 222
#define MB_MUIA_AppMessage 223
#define MB_MUIA_HelpFile 224
#define MB_MUIA_HelpLine 225
#define MB_MUIA_HelpNode 226
#define MB_MUIA_NoNotify 227
#define MB_MUIA_Revision 228
#define MB_MUIA_UserData 229
#define MB_MUIA_Version 230
#define MB_MUIC_Application 231
#define MB_MUIM_Application_GetMenuCheck 232
#define MB_MUIM_Application_GetMenuState 233
#define MB_MUIM_Application_Input 234
#define MB_MUIM_Application_InputBuffered 235
#define MB_MUIM_Application_Load 236
#define MB_MUIM_Application_PushMethod 237
#define MB_MUIM_Application_ReturnID 238
#define MB_MUIM_Application_Save 239
#define MB_MUIM_Application_SetMenuCheck 240
#define MB_MUIM_Application_SetMenuState 241
#define MB_MUIM_Application_ShowHelp 242
#define MB_MUIA_Application_Active 243
#define MB_MUIA_Application_Author 244
#define MB_MUIA_Application_Base 245
#define MB_MUIA_Application_Broker 246
#define MB_MUIA_Application_BrokerHook 247
#define MB_MUIA_Application_BrokerPort 248
#define MB_MUIA_Application_BrokerPri 249
#define MB_MUIA_Application_Commands 250
#define MB_MUIA_Application_Copyright 251
#define MB_MUIA_Application_Description 252
#define MB_MUIA_Application_DiskObject 253
#define MB_MUIA_Application_DoubleStart 254
#define MB_MUIA_Application_DropObject 255
#define MB_MUIA_Application_Iconified 256
#define MB_MUIA_Application_Menu 257
#define MB_MUIA_Application_MenuAction 258
#define MB_MUIA_Application_MenuHelp 259
#define MB_MUIA_Application_RexxHook 260
#define MB_MUIA_Application_RexxMsg 261
#define MB_MUIA_Application_RexxString 262
#define MB_MUIA_Application_SingleTask 263
#define MB_MUIA_Application_Sleep 264
#define MB_MUIA_Application_Title 265
#define MB_MUIA_Application_Version 266
#define MB_MUIA_Application_Window 267
#define MB_MUIC_Window 268
#define MB_MUIM_Window_GetMenuCheck 269
#define MB_MUIM_Window_GetMenuState 270
#define MB_MUIM_Window_ScreenToBack 271
#define MB_MUIM_Window_ScreenToFront 272
#define MB_MUIM_Window_SetCycleChain 273
#define MB_MUIM_Window_SetMenuCheck 274
#define MB_MUIM_Window_SetMenuState 275
#define MB_MUIM_Window_ToBack 276
#define MB_MUIM_Window_ToFront 277
#define MB_MUIA_Window_Activate 278
#define MB_MUIA_Window_ActiveObject 279
#define MB_MUIA_Window_AltHeight 280
#define MB_MUIA_Window_AltLeftEdge 281
#define MB_MUIA_Window_AltTopEdge 282
#define MB_MUIA_Window_AltWidth 283
#define MB_MUIA_Window_AppWindow 284
#define MB_MUIA_Window_Backdrop 285
#define MB_MUIA_Window_Borderless 286
#define MB_MUIA_Window_CloseGadget 287
#define MB_MUIA_Window_CloseRequest 288
#define MB_MUIA_Window_DefaultObject 289
#define MB_MUIA_Window_DepthGadget 290
#define MB_MUIA_Window_DragBar 291
#define MB_MUIA_Window_Height 292
#define MB_MUIA_Window_ID 293
#define MB_MUIA_Window_InputEvent 294
#define MB_MUIA_Window_LeftEdge 295
#define MB_MUIA_Window_Menu 296
#define MB_MUIA_Window_NoMenus 297
#define MB_MUIA_Window_Open 298
#define MB_MUIA_Window_PublicScreen 299
#define MB_MUIA_Window_RefWindow 300
#define MB_MUIA_Window_RootObject 301
#define MB_MUIA_Window_Screen 302
#define MB_MUIA_Window_ScreenTitle 303
#define MB_MUIA_Window_SizeGadget 304
#define MB_MUIA_Window_SizeRight 305
#define MB_MUIA_Window_Sleep 306
#define MB_MUIA_Window_Title 307
#define MB_MUIA_Window_TopEdge 308
#define MB_MUIA_Window_Width 309
#define MB_MUIA_Window_Window 310
#define MB_MUIV_Window_ActiveObject_None 311
#define MB_MUIV_Window_ActiveObject_Next 312
#define MB_MUIV_Window_ActiveObject_Prev 313
#define MB_MUIV_Window_AltHeight_MinMax 314
#define MB_MUIV_Window_AltHeight_Visible 315
#define MB_MUIV_Window_AltHeight_Screen 316
#define MB_MUIV_Window_AltHeight_Scaled 317
#define MB_MUIV_Window_AltLeftEdge_Centered 318
#define MB_MUIV_Window_AltLeftEdge_Moused 319
#define MB_MUIV_Window_AltLeftEdge_NoChange 320
#define MB_MUIV_Window_AltTopEdge_Centered 321
#define MB_MUIV_Window_AltTopEdge_Moused 322
#define MB_MUIV_Window_AltTopEdge_Delta 323
#define MB_MUIV_Window_AltTopEdge_NoChange 324
#define MB_MUIV_Window_AltWidth_MinMax 325
#define MB_MUIV_Window_AltWidth_Visible 326
#define MB_MUIV_Window_AltWidth_Screen 327
#define MB_MUIV_Window_AltWidth_Scaled 328
#define MB_MUIV_Window_Height_MinMax 329
#define MB_MUIV_Window_Height_Visible 330
#define MB_MUIV_Window_Height_Screen 331
#define MB_MUIV_Window_Height_Scaled 332
#define MB_MUIV_Window_Height_Default 333
#define MB_MUIV_Window_LeftEdge_Centered 334
#define MB_MUIV_Window_LeftEdge_Moused 335
#define MB_MUIV_Window_Menu_NoMenu 336
#define MB_MUIV_Window_TopEdge_Centered 337
#define MB_MUIV_Window_TopEdge_Moused 338
#define MB_MUIV_Window_TopEdge_Delta 339
#define MB_MUIV_Window_Width_MinMax 340
#define MB_MUIV_Window_Width_Visible 341
#define MB_MUIV_Window_Width_Screen 342
#define MB_MUIV_Window_Width_Scaled 343
#define MB_MUIV_Window_Width_Default 344
#define MB_MUIC_Area 345
#define MB_MUIM_AskMinMax 346
#define MB_MUIM_Cleanup 347
#define MB_MUIM_Draw 348
#define MB_MUIM_HandleInput 349
#define MB_MUIM_Hide 350
#define MB_MUIM_Setup 351
#define MB_MUIM_Show 352
#define MB_MUIA_ApplicationObject 353
#define MB_MUIA_Background 354
#define MB_MUIA_BottomEdge 355
#define MB_MUIA_ControlChar 356
#define MB_MUIA_Disabled 357
#define MB_MUIA_ExportID 358
#define MB_MUIA_FixHeight 359
#define MB_MUIA_FixHeightTxt 360
#define MB_MUIA_FixWidth 361
#define MB_MUIA_FixWidthTxt 362
#define MB_MUIA_Font 363
#define MB_MUIA_Frame 364
#define MB_MUIA_FramePhantomHoriz 365
#define MB_MUIA_FrameTitle 366
#define MB_MUIA_Height 367
#define MB_MUIA_HorizWeight 368
#define MB_MUIA_InnerBottom 369
#define MB_MUIA_InnerLeft 370
#define MB_MUIA_InnerRight 371
#define MB_MUIA_InnerTop 372
#define MB_MUIA_InputMode 373
#define MB_MUIA_LeftEdge 374
#define MB_MUIA_Pressed 375
#define MB_MUIA_RightEdge 376
#define MB_MUIA_Selected 377
#define MB_MUIA_ShowMe 378
#define MB_MUIA_ShowSelState 379
#define MB_MUIA_Timer 380
#define MB_MUIA_TopEdge 381
#define MB_MUIA_VertWeight 382
#define MB_MUIA_Weight 383
#define MB_MUIA_Width 384
#define MB_MUIA_Window 385
#define MB_MUIA_WindowObject 386
#define MB_MUIV_Font_Inherit 387
#define MB_MUIV_Font_Normal 388
#define MB_MUIV_Font_List 389
#define MB_MUIV_Font_Tiny 390
#define MB_MUIV_Font_Fixed 391
#define MB_MUIV_Font_Title 392
#define MB_MUIV_Frame_None 393
#define MB_MUIV_Frame_Button 394
#define MB_MUIV_Frame_ImageButton 395
#define MB_MUIV_Frame_Text 396
#define MB_MUIV_Frame_String 397
#define MB_MUIV_Frame_ReadList 398
#define MB_MUIV_Frame_InputList 399
#define MB_MUIV_Frame_Prop 400
#define MB_MUIV_Frame_Gauge 401
#define MB_MUIV_Frame_Group 402
#define MB_MUIV_Frame_PopUp 403
#define MB_MUIV_Frame_Virtual 404
#define MB_MUIV_Frame_Slider 405
#define MB_MUIV_Frame_Count 406
#define MB_MUIV_InputMode_None 407
#define MB_MUIV_InputMode_RelVerify 408
#define MB_MUIV_InputMode_Immediate 409
#define MB_MUIV_InputMode_Toggle 410
#define MB_MUIC_Rectangle 411
#define MB_MUIA_Rectangle_HBar 412
#define MB_MUIA_Rectangle_VBar 413
#define MB_MUIC_Image 414
#define MB_MUIA_Image_FontMatch 415
#define MB_MUIA_Image_FontMatchHeight 416
#define MB_MUIA_Image_FontMatchWidth 417
#define MB_MUIA_Image_FreeHoriz 418
#define MB_MUIA_Image_FreeVert 419
#define MB_MUIA_Image_OldImage 420
#define MB_MUIA_Image_Spec 421
#define MB_MUIA_Image_State 422
#define MB_MUIC_Text 423
#define MB_MUIA_Text_Contents 424
#define MB_MUIA_Text_HiChar 425
#define MB_MUIA_Text_PreParse 426
#define MB_MUIA_Text_SetMax 427
#define MB_MUIA_Text_SetMin 428
#define MB_MUIC_String 429
#define MB_MUIA_String_Accept 430
#define MB_MUIA_String_Acknowledge 431
#define MB_MUIA_String_AttachedList 432
#define MB_MUIA_String_BufferPos 433
#define MB_MUIA_String_Contents 434
#define MB_MUIA_String_DisplayPos 435
#define MB_MUIA_String_EditHook 436
#define MB_MUIA_String_Format 437
#define MB_MUIA_String_Integer 438
#define MB_MUIA_String_MaxLen 439
#define MB_MUIA_String_Reject 440
#define MB_MUIA_String_Secret 441
#define MB_MUIV_String_Format_Left 442
#define MB_MUIV_String_Format_Center 443
#define MB_MUIV_String_Format_Right 444
#define MB_MUIC_Prop 445
#define MB_MUIA_Prop_Entries 446
#define MB_MUIA_Prop_First 447
#define MB_MUIA_Prop_Horiz 448
#define MB_MUIA_Prop_Slider 449
#define MB_MUIA_Prop_Visible 450
#define MB_MUIC_Gauge 451
#define MB_MUIA_Gauge_Current 452
#define MB_MUIA_Gauge_Divide 453
#define MB_MUIA_Gauge_Horiz 454
#define MB_MUIA_Gauge_InfoText 455
#define MB_MUIA_Gauge_Max 456
#define MB_MUIC_Scale 457
#define MB_MUIA_Scale_Horiz 458
#define MB_MUIC_Boopsi 459
#define MB_MUIA_Boopsi_Class 460
#define MB_MUIA_Boopsi_ClassID 461
#define MB_MUIA_Boopsi_MaxHeight 462
#define MB_MUIA_Boopsi_MaxWidth 463
#define MB_MUIA_Boopsi_MinHeight 464
#define MB_MUIA_Boopsi_MinWidth 465
#define MB_MUIA_Boopsi_Object 466
#define MB_MUIA_Boopsi_Remember 467
#define MB_MUIA_Boopsi_TagDrawInfo 468
#define MB_MUIA_Boopsi_TagScreen 469
#define MB_MUIA_Boopsi_TagWindow 470
#define MB_MUIC_Colorfield 471
#define MB_MUIA_Colorfield_Blue 472
#define MB_MUIA_Colorfield_Green 473
#define MB_MUIA_Colorfield_Pen 474
#define MB_MUIA_Colorfield_Red 475
#define MB_MUIA_Colorfield_RGB 476
#define MB_MUIC_List 477
#define MB_MUIM_List_Clear 478
#define MB_MUIM_List_Exchange 479
#define MB_MUIM_List_GetEntry 480
#define MB_MUIM_List_Insert 481
#define MB_MUIM_List_InsertSingle 482
#define MB_MUIM_List_Jump 483
#define MB_MUIM_List_NextSelected 484
#define MB_MUIM_List_Redraw 485
#define MB_MUIM_List_Remove 486
#define MB_MUIM_List_Select 487
#define MB_MUIM_List_Sort 488
#define MB_MUIA_List_Active 489
#define MB_MUIA_List_AdjustHeight 490
#define MB_MUIA_List_AdjustWidth 491
#define MB_MUIA_List_CompareHook 492
#define MB_MUIA_List_ConstructHook 493
#define MB_MUIA_List_DestructHook 494
#define MB_MUIA_List_DisplayHook 495
#define MB_MUIA_List_Entries 496
#define MB_MUIA_List_First 497
#define MB_MUIA_List_Format 498
#define MB_MUIA_List_MultiTestHook 499
#define MB_MUIA_List_Quiet 500
#define MB_MUIA_List_SourceArray 501
#define MB_MUIA_List_Title 502
#define MB_MUIA_List_Visible 503
#define MB_MUIV_List_Active_Off 504
#define MB_MUIV_List_Active_Top 505
#define MB_MUIV_List_Active_Bottom 506
#define MB_MUIV_List_Active_Up 507
#define MB_MUIV_List_Active_Down 508
#define MB_MUIV_List_Active_PageUp 509
#define MB_MUIV_List_Active_PageDown 510
#define MB_MUIV_List_ConstructHook_String 511
#define MB_MUIV_List_CopyHook_String 512
#define MB_MUIV_List_CursorType_None 513
#define MB_MUIV_List_CursorType_Bar 514
#define MB_MUIV_List_CursorType_Rect 515
#define MB_MUIV_List_DestructHook_String 516
#define MB_MUIC_Floattext 517
#define MB_MUIA_Floattext_Justify 518
#define MB_MUIA_Floattext_SkipChars 519
#define MB_MUIA_Floattext_TabSize 520
#define MB_MUIA_Floattext_Text 521
#define MB_MUIC_Volumelist 522
#define MB_MUIC_Scrmodelist 523
#define MB_MUIC_Dirlist 524
#define MB_MUIM_Dirlist_ReRead 525
#define MB_MUIA_Dirlist_AcceptPattern 526
#define MB_MUIA_Dirlist_Directory 527
#define MB_MUIA_Dirlist_DrawersOnly 528
#define MB_MUIA_Dirlist_FilesOnly 529
#define MB_MUIA_Dirlist_FilterDrawers 530
#define MB_MUIA_Dirlist_FilterHook 531
#define MB_MUIA_Dirlist_MultiSelDirs 532
#define MB_MUIA_Dirlist_NumBytes 533
#define MB_MUIA_Dirlist_NumDrawers 534
#define MB_MUIA_Dirlist_NumFiles 535
#define MB_MUIA_Dirlist_Path 536
#define MB_MUIA_Dirlist_RejectIcons 537
#define MB_MUIA_Dirlist_RejectPattern 538
#define MB_MUIA_Dirlist_SortDirs 539
#define MB_MUIA_Dirlist_SortHighLow 540
#define MB_MUIA_Dirlist_SortType 541
#define MB_MUIA_Dirlist_Status 542
#define MB_MUIV_Dirlist_SortDirs_First 543
#define MB_MUIV_Dirlist_SortDirs_Last 544
#define MB_MUIV_Dirlist_SortDirs_Mix 545
#define MB_MUIV_Dirlist_SortType_Name 546
#define MB_MUIV_Dirlist_SortType_Date 547
#define MB_MUIV_Dirlist_SortType_Size 548
#define MB_MUIV_Dirlist_Status_Invalid 549
#define MB_MUIV_Dirlist_Status_Reading 550
#define MB_MUIV_Dirlist_Status_Valid 551
#define MB_MUIC_Group 552
#define MB_MUIA_Group_ActivePage 553
#define MB_MUIA_Group_Child 554
#define MB_MUIA_Group_Columns 555
#define MB_MUIA_Group_Horiz 556
#define MB_MUIA_Group_HorizSpacing 557
#define MB_MUIA_Group_PageMode 558
#define MB_MUIA_Group_Rows 559
#define MB_MUIA_Group_SameHeight 560
#define MB_MUIA_Group_SameSize 561
#define MB_MUIA_Group_SameWidth 562
#define MB_MUIA_Group_Spacing 563
#define MB_MUIA_Group_VertSpacing 564
#define MB_MUIC_Register 565
#define MB_MUIA_Register_Frame 566
#define MB_MUIA_Register_Titles 567
#define MB_MUIC_Virtgroup 568
#define MB_MUIA_Virtgroup_Height 569
#define MB_MUIA_Virtgroup_Left 570
#define MB_MUIA_Virtgroup_Top 571
#define MB_MUIA_Virtgroup_Width 572
#define MB_MUIC_Scrollgroup 573
#define MB_MUIA_Scrollgroup_Contents 574
#define MB_MUIC_Scrollbar 575
#define MB_MUIC_Listview 576
#define MB_MUIA_Listview_ClickColumn 577
#define MB_MUIA_Listview_DefClickColumn 578
#define MB_MUIA_Listview_DoubleClick 579
#define MB_MUIA_Listview_Input 580
#define MB_MUIA_Listview_List 581
#define MB_MUIA_Listview_MultiSelect 582
#define MB_MUIA_Listview_SelectChange 583
#define MB_MUIV_Listview_MultiSelect_None 584
#define MB_MUIV_Listview_MultiSelect_Default 585
#define MB_MUIV_Listview_MultiSelect_Shifted 586
#define MB_MUIV_Listview_MultiSelect_Always 587
#define MB_MUIC_Radio 588
#define MB_MUIA_Radio_Active 589
#define MB_MUIA_Radio_Entries 590
#define MB_MUIC_Cycle 591
#define MB_MUIA_Cycle_Active 592
#define MB_MUIA_Cycle_Entries 593
#define MB_MUIV_Cycle_Active_Next 594
#define MB_MUIV_Cycle_Active_Prev 595
#define MB_MUIC_Slider 596
#define MB_MUIA_Slider_Level 597
#define MB_MUIA_Slider_Max 598
#define MB_MUIA_Slider_Min 599
#define MB_MUIA_Slider_Quiet 600
#define MB_MUIA_Slider_Reverse 601
#define MB_MUIC_Coloradjust 602
#define MB_MUIA_Coloradjust_Blue 603
#define MB_MUIA_Coloradjust_Green 604
#define MB_MUIA_Coloradjust_ModeID 605
#define MB_MUIA_Coloradjust_Red 606
#define MB_MUIA_Coloradjust_RGB 607
#define MB_MUIC_Palette 608
#define MB_MUIA_Palette_Entries 609
#define MB_MUIA_Palette_Groupable 610
#define MB_MUIA_Palette_Names 611
#define MB_MUIC_Colorpanel 612
#define MB_MUIC_Popstring 613
#define MB_MUIM_Popstring_Close 614
#define MB_MUIM_Popstring_Open 615
#define MB_MUIA_Popstring_Button 616
#define MB_MUIA_Popstring_CloseHook 617
#define MB_MUIA_Popstring_OpenHook 618
#define MB_MUIA_Popstring_String 619
#define MB_MUIA_Popstring_Toggle 620
#define MB_MUIC_Popobject 621
#define MB_MUIA_Popobject_Follow 622
#define MB_MUIA_Popobject_Light 623
#define MB_MUIA_Popobject_Object 624
#define MB_MUIA_Popobject_ObjStrHook 625
#define MB_MUIA_Popobject_StrObjHook 626
#define MB_MUIA_Popobject_Volatile 627
#define MB_MUIC_Popasl 628
#define MB_MUIA_Popasl_Active 629
#define MB_MUIA_Popasl_StartHook 630
#define MB_MUIA_Popasl_StopHook 631
#define MB_MUIA_Popasl_Type 632
#define MB_MUI_MAXMAX 633
#define MB_MADF_DRAWOBJECT 634
#define MB_MADF_DRAWUPDATE 635
#define MB_MPEN_SHINE 636
#define MB_MPEN_HALFSHINE 637
#define MB_MPEN_BACKGROUND 638
#define MB_MPEN_HALFSHADOW 639
#define MB_MPEN_SHADOW 640
#define MB_MPEN_TEXT 641
#define MB_MPEN_FILL 642
#define MB_MPEN_ACTIVEOBJ 643
#define MB_MPEN_COUNT 644
#define MB_muiNotifyData 645
#define MB_muiAreaData 646
#define MB_muiGlobalInfo 647
#define MB_muiRenderInfo 648
#define MB__app 649
#define MB__win 650
#define MB__dri 651
#define MB__window 652
#define MB__screen 653
#define MB__rp 654
#define MB__left 655
#define MB__top 656
#define MB__width 657
#define MB__height 658
#define MB__right 659
#define MB__bottom 660
#define MB__addleft 661
#define MB__addtop 662
#define MB__subwidth 663
#define MB__subheight 664
#define MB__mleft 665
#define MB__mtop 666
#define MB__mwidth 667
#define MB__mheight 668
#define MB__mright 669
#define MB__mbottom 670
#define MB__font 671
#define MB__flags 672
#define MB_MAKE_ID 673
#define MB_ETKeyButton 674
#define MB_DoMethod 675
#define MB_MUIO_Label 676
#define MB_MUIO_Button 677
#define MB_MUIO_Checkmark 678
#define MB_MUIO_Cycle 679
#define MB_MUIO_Radio 680
#define MB_MUIO_Slider 681
#define MB_MUIO_String 682
#define MB_MUIO_PopButton 683
#define MB_MUIO_HSpace 684
#define MB_MUIO_VSpace 685
#define MB_MUIO_HBar 686
#define MB_MUIO_VBar 687
#define MB_MUIO_MenustripNM 688
#define MB_MUIO_Menuitem 689
#define MB_MUIO_BarTitle 690
#define MB_MUIO_Label_SingleFrame 691
#define MB_MUIO_Label_DoubleFrame 692
#define MB_MUIO_Label_LeftAligned 693
#define MB_MUII_PopupBack 694
#define MB_MUIV_NotTriggerValue 695
#define MB_MenustripObject 696
#define MB_MenuObject 697
#define MB_MenuObjectT 698
#define MB_MenuitemObject 699
#define MB_BitmapObject 700
#define MB_BodychunkObject 701
#define MB_PoplistObject 702
#define MB_MUIM_FindUData 703
#define MB_MUIM_GetUData 704
#define MB_MUIM_SetUData 705
#define MB_MUIC_Family 706
#define MB_MUIM_Family_AddHead 707
#define MB_MUIM_Family_AddTail 708
#define MB_MUIM_Family_Insert 709
#define MB_MUIM_Family_Remove 710
#define MB_MUIM_Family_Sort 711
#define MB_MUIM_Family_Transfer 712
#define MB_MUIA_Family_Child 713
#define MB_MUIC_Menustrip 714
#define MB_MUIA_Menustrip_Enabled 715
#define MB_MUIC_Menu 716
#define MB_MUIA_Menu_Enabled 717
#define MB_MUIA_Menu_Title 718
#define MB_MUIC_Menuitem 719
#define MB_MUIA_Menuitem_Checked 720
#define MB_MUIA_Menuitem_Checkit 721
#define MB_MUIA_Menuitem_Enabled 722
#define MB_MUIA_Menuitem_Exclude 723
#define MB_MUIA_Menuitem_Shortcut 724
#define MB_MUIA_Menuitem_Title 725
#define MB_MUIA_Menuitem_Toggle 726
#define MB_MUIA_Menuitem_Trigger 727
#define MB_MUIA_Application_ForceQuit 728
#define MB_MUIA_Application_HelpFile 729
#define MB_MUIA_Application_Menustrip 730
#define MB_MUIA_Window_FancyDrawing 731
#define MB_MUIA_Window_MenuAction 732
#define MB_MUIA_Window_Menustrip 733
#define MB_MUIV_Font_Big 734
#define MB_MUIC_Bitmap 735
#define MB_MUIA_Bitmap_Bitmap 736
#define MB_MUIA_Bitmap_Height 737
#define MB_MUIA_Bitmap_MappingTable 738
#define MB_MUIA_Bitmap_SourceColors 739
#define MB_MUIA_Bitmap_Transparent 740
#define MB_MUIA_Bitmap_Width 741
#define MB_MUIC_Bodychunk 742
#define MB_MUIA_Bodychunk_Body 743
#define MB_MUIA_Bodychunk_Compression 744
#define MB_MUIA_Bodychunk_Depth 745
#define MB_MUIA_Bodychunk_Masking 746
#define MB_MUIC_Poplist 747
#define MB_MUIA_Poplist_Array 748
#define MB_muiUserData 749
#define MB_MUI_MakeObject 750
#define MB_MN_BARLABEL 751
#define MB_MUI_OBSOLETE 752
#define MB_MUIO_Label_Centered 753
#define MB_MUIV_Notify_Self 754
#define MB_MUIV_Notify_Window 755
#define MB_MUIV_Notify_Application 756
#define MB_MUIV_List_Remove_Selected 757
#define MB_MUIV_List_Move_Top 758
#define MB_MUIV_List_Move_Active 759
#define MB_MUIV_List_Move_Bottom 760
#define MB_MUIV_List_Move_Next 761
#define MB_MUIV_List_Move_Previous 762
#define MB_MUIV_List_Exchange_Top 763
#define MB_MUIV_List_Exchange_Bottom 764
#define MB_MUIV_List_Exchange_Next 765
#define MB_MUIV_List_Exchange_Previous 766
#define MB_MUIV_List_Jump_Top 767
#define MB_MUIV_List_Jump_Bottom 768
#define MB_MUIV_List_NextSelected_Start 769
#define MB_MUIV_List_NextSelected_End 770
#define MB_MUIM_NoNotifySet 771
#define MB_MUIA_Application_UseCommodities 772
#define MB_MUIA_Application_UseRexx 773
#define MB_MUIA_Window_MouseObject 774
#define MB_MUIA_Window_NeedsMouseObject 775
#define MB_MUIA_Boopsi_Smart 776
#define MB_MUIM_List_Move 777
#define MB_MUIA_List_InsertPosition 778
#define MB_MUIV_Group_ActivePage_First 779
#define MB_MUIV_Group_ActivePage_Last 780
#define MB_MUIV_Group_ActivePage_Prev 781
#define MB_MUIV_Group_ActivePage_Next 782
#define MB_MUIA_Scrollgroup_FreeHoriz 783
#define MB_MUIA_Scrollgroup_FreeVert 784
#define MB_MUIA_Listview_ScrollerPos 785
#define MB_MUIV_Listview_ScrollerPos_Default 786
#define MB_MUIV_Listview_ScrollerPos_Left 787
#define MB_MUIV_Listview_ScrollerPos_Right 788
#define MB_MUIA_Popobject_WindowHook 789

#endif
