// DefaultMenu.c
// $Date$
// $Revision$

#include <exec/types.h>
#include <utility/hooks.h>
#include <intuition/classusr.h>
#include <scalos/scalosprefsplugin.h>
#include <scalos/scalosmenuprefsplugin.h>
#include <defs.h>

#define	ScalosMenu_NUMBERS
#include STR(SCALOSLOCALE)

#include "MenuPrefs.h"

#define	MSGID_MENU_SEPARATOR    MSGID_DEFAULT_MENU_EMPTY_SHORT

const struct DefaultMenuEntry DefaultMenu[] =
	{
	{ SCAMENUTYPE_Menu, 0, MSGID_DEFAULT_MENU_SCALOS, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_MainMenu },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_COM_UNDO, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "undo", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_COM_REDO, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "redo", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_LastInsertedMenu },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_BACKDROP, MSGID_DEFAULT_MENU_BACKDROP_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "backdrop", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_EXECUTECOMMAND, MSGID_DEFAULT_MENU_EXECUTECOMMAND_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "executecommand", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_REDRAWALL, MSGID_DEFAULT_MENU_REDRAWALL_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "redrawall", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_UPDATEALL, MSGID_DEFAULT_MENU_UPDATEALL_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "updateall", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_LASTMESSAGE, MSGID_DEFAULT_MENU_UPDATEALL_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "lastmsg", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_ABOUT, MSGID_DEFAULT_MENU_ABOUT_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "about", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_LastInsertedMenu },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_QUIT, MSGID_DEFAULT_MENU_QUIT_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "quit", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_Menu, 0, MSGID_DEFAULT_MENU_WINDOW, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_MainMenu },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_NEWDRAWER, MSGID_DEFAULT_MENU_NEWDRAWER_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "makedir", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_OPENPARENT, MSGID_DEFAULT_MENU_OPENPARENT_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "parent", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_CLOSE, MSGID_DEFAULT_MENU_CLOSE_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "close", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_UPDATE, MSGID_DEFAULT_MENU_UPDATE_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "update", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_SELECTCONTENTS, MSGID_DEFAULT_MENU_SELECTCONTENTS_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "selectall", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_CLEARSELECTION, MSGID_DEFAULT_MENU_CLEARSELECTION_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "clearselection", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_Menu, 1, MSGID_DEFAULT_MENU_CLEANUPBY, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_CLEANUPBY_COLUMN, MSGID_DEFAULT_MENU_CLEANUPBY_COLUMN_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
				{ SCAMENUTYPE_Command, 3, (IPTR) "Scalos:Plugins/Menu/sorted_cleanup.plugin", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Plugin },
			{ SCAMENUTYPE_MenuItem, 2, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_CLEANUPBY_NAME, MSGID_DEFAULT_MENU_CLEANUPBY_NAME_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
				{ SCAMENUTYPE_Command, 3, (IPTR) "cleanupbyname", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
			{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_CLEANUPBY_DATE, MSGID_DEFAULT_MENU_CLEANUPBY_DATE_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
				{ SCAMENUTYPE_Command, 3, (IPTR) "cleanupbydate", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
			{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_CLEANUPBY_SIZE, MSGID_DEFAULT_MENU_CLEANUPBY_SIZE_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
				{ SCAMENUTYPE_Command, 3, (IPTR) "cleanupbysize", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
			{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_CLEANUPBY_TYPE, MSGID_DEFAULT_MENU_CLEANUPBY_TYPE_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
				{ SCAMENUTYPE_Command, 3, (IPTR) "cleanupbytype", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_RESIZETOFIT, MSGID_DEFAULT_MENU_RESIZETOFIT_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "sizetofit", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_Menu, 1, MSGID_DEFAULT_MENU_SNAPSHOT, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_SNAPSHOT_WINDOW, MSGID_DEFAULT_MENU_SNAPSHOT_WINDOW_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
				{ SCAMENUTYPE_Command, 3, (IPTR) "snapshotwindow", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
			{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_SNAPSHOT_ALL, MSGID_DEFAULT_MENU_SNAPSHOT_ALL_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
				{ SCAMENUTYPE_Command, 3, (IPTR) "snapshotall", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_Menu, 1, MSGID_DEFAULT_MENU_SHOW, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_SHOW_DEFAULT, MSGID_DEFAULT_MENU_SHOW_DEFAULT_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
				{ SCAMENUTYPE_Command, 3, (IPTR) "showdefault", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
			{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_SHOW_ONLYICONS, MSGID_DEFAULT_MENU_SHOW_DEFAULT_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
				{ SCAMENUTYPE_Command, 3, (IPTR) "showonlyicons", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
			{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_SHOW_ALLFILES, MSGID_DEFAULT_MENU_SHOW_ALLFILES_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
				{ SCAMENUTYPE_Command, 3, (IPTR) "showallfiles", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_Menu, 1, MSGID_DEFAULT_MENU_VIEWBY, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_VIEWBY_DEFAULT, MSGID_DEFAULT_MENU_VIEWBY_DEFAULT_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
				{ SCAMENUTYPE_Command, 3, (IPTR) "viewbydefault", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
			{ SCAMENUTYPE_MenuItem, 2, 0, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_VIEWBY_ICON, MSGID_DEFAULT_MENU_VIEWBY_ICON_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
				{ SCAMENUTYPE_Command, 3, (IPTR) "viewbyicon", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
			{ SCAMENUTYPE_MenuItem, 2, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_VIEWBY_NAME, MSGID_DEFAULT_MENU_VIEWBY_NAME_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
				{ SCAMENUTYPE_Command, 3, (IPTR) "viewbytext", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
			{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_VIEWBY_DATE, MSGID_DEFAULT_MENU_VIEWBY_DATE_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
				{ SCAMENUTYPE_Command, 3, (IPTR) "viewbydate", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
			{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_VIEWBY_SIZE, MSGID_DEFAULT_MENU_VIEWBY_SIZE_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
				{ SCAMENUTYPE_Command, 3, (IPTR) "viewbysize", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
			{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_VIEWBY_TYPE, MSGID_DEFAULT_MENU_VIEWBY_TYPE_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
				{ SCAMENUTYPE_Command, 3, (IPTR) "viewbytype", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_LastInsertedMenu },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_FIND, MSGID_DEFAULT_MENU_FIND_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "System:System/Find", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, MCOMFLGF_Args, DEFAULT_STACKSIZE },
	{ SCAMENUTYPE_Menu, 0, MSGID_DEFAULT_MENU_ICONS, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_MainMenu },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_OPEN, MSGID_DEFAULT_MENU_OPEN_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "open", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_CLONE, MSGID_DEFAULT_MENU_CLONE_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "clone", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_RENAME, MSGID_DEFAULT_MENU_RENAME_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "rename", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_INFORMATION, MSGID_DEFAULT_MENU_INFORMATION_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "iconinfo", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_SNAPSHOT, MSGID_DEFAULT_MENU_SNAPSHOT_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "snapshot", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_UNSNAPSHOT, MSGID_DEFAULT_MENU_UNSNAPSHOT_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "unsnapshot", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_LEAVEOUT, MSGID_DEFAULT_MENU_LEAVEOUT_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "leaveout", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_PUTAWAY, MSGID_DEFAULT_MENU_PUTAWAY_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "putaway", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_LastInsertedMenu },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_DELETE, MSGID_DEFAULT_MENU_DELETE_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "delete", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_FORMAT, MSGID_DEFAULT_MENU_FORMAT_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "formatdisk", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_EMPTYTRASH, MSGID_DEFAULT_MENU_EMPTYTRASH_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "emptytrashcan", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_ToolsMenu, 0, MSGID_TOOLS_MENU, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_MainMenu },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_RESETSCALOS, MSGID_DEFAULT_MENU_RESETSCALOS_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "reset", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_LastInsertedMenu },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_NEWSHELL, MSGID_DEFAULT_MENU_NEWSHELL_SHORT, DEFAULTPARENTNODE_LastInsertedMenu },
#if defined(__MORPHOS__) || defined(__AROS__)
			{ SCAMENUTYPE_Command, 2, (IPTR) "c:NewShell \"CON:190/295/700/412/Scalos Shell/CLOSE\"", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_AmigaDOS, 0, 0, DEFAULT_STACKSIZE },
#else /* __MORPHOS__ */
			{ SCAMENUTYPE_Command, 2, (IPTR) "SYS:System/CLI \"KCON:0/235/645/290/ToolManager Shell/C\"", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_AmigaDOS, 0, 0, DEFAULT_STACKSIZE },
#endif /* __MORPHOS__ */
	{ SCAMENUTYPE_Menu, 0, MSGID_DEFAULT_MENU_DRAWERS, MSGID_DEFAULT_MENU_EMPTY_SHORT,  },
#if defined(__MORPHOS__)
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_DRAWERS_VOYAGER, MSGID_DEFAULT_MENU_DRAWERS_VOYAGER_SHORT, DEFAULTPARENTNODE_MainMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "SYS:Apps/Voyager", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_IconWindow },
#endif /* __MORPHOS__ */
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_DRAWERS_ENVARC_SYS, MSGID_DEFAULT_MENU_DRAWERS_ENVARC_SYS_SHORT, DEFAULTPARENTNODE_MainMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "ENVARC:Sys/", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_IconWindow },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_DRAWERS_WBSTARTUP, MSGID_DEFAULT_MENU_DRAWERS_WBSTARTUP_SHORT, DEFAULTPARENTNODE_MainMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "SYS:WBStartup", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_IconWindow },
		{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_MainMenu },
#if !defined(__MORPHOS__)
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_DRAWERS_PREFS, MSGID_DEFAULT_MENU_DRAWERS_PREFS_SHORT, DEFAULTPARENTNODE_MainMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "SYS:Prefs/", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_IconWindow },
#endif /* __MORPHOS__ */
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_DRAWERS_SCALOSPREFS, MSGID_DEFAULT_MENU_DRAWERS_SCALOSPREFS_SHORT, DEFAULTPARENTNODE_MainMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "Scalos:Prefs", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_IconWindow },
#if defined(__MORPHOS__)
	{ SCAMENUTYPE_Menu, 0, MSGID_DEFAULT_MENU_PREFS, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_MainMenu },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_PREFS_SYSTEM, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_MainMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "MOSSYS:Prefs/Preferences", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_PREFS_MUI, MSGID_DEFAULT_MENU_PREFS_MUI_SHORT, DEFAULTPARENTNODE_MainMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "MOSSYS:Prefs/MUI", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
//		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_PREFS_AHI, MSGID_DEFAULT_MENU_PREFS_AHI_SHORT, DEFAULTPARENTNODE_MainMenu },
//			{ SCAMENUTYPE_Command, 2, (IPTR) "MOSSYS:Prefs/AHI", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_MainMenu },
		{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_PREFS_SCALOS, MSGID_DEFAULT_MENU_PREFS_SCALOS_SHORT, DEFAULTPARENTNODE_MainMenu },
			{ SCAMENUTYPE_Command, 2, (IPTR) "Scalos:Prefs/Scalos Prefs", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
#endif /* __MORPHOS__ */

	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_OPEN, MSGID_DEFAULT_MENU_OPEN_SHORT, DEFAULTPARENTNODE_Popup_Disk },
		{ SCAMENUTYPE_Command, 2, (IPTR) "open", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_INFORMATION, MSGID_DEFAULT_MENU_INFORMATION_SHORT, DEFAULTPARENTNODE_Popup_Disk },
		{ SCAMENUTYPE_Command, 2, (IPTR) "iconinfo", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_Popup_Disk },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_BROWSE, MSGID_DEFAULT_MENU_BROWSE_SHORT, DEFAULTPARENTNODE_Popup_Disk },
		{ SCAMENUTYPE_Command, 2, (IPTR) "Scalos:Tools/browse.script %%p", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_AmigaDOS, 0, MCOMFLGF_Args, DEFAULT_STACKSIZE },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_FIND, MSGID_DEFAULT_MENU_FIND_SHORT, DEFAULTPARENTNODE_Popup_Disk },
		{ SCAMENUTYPE_Command, 2, (IPTR) "System:System/Find", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, MCOMFLGF_Args, DEFAULT_STACKSIZE },
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_Popup_Disk },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_SNAPSHOT, MSGID_DEFAULT_MENU_SNAPSHOT_SHORT, DEFAULTPARENTNODE_Popup_Disk },
		{ SCAMENUTYPE_Command, 2, (IPTR) "snapshot", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_UNSNAPSHOT, MSGID_DEFAULT_MENU_UNSNAPSHOT_SHORT, DEFAULTPARENTNODE_Popup_Disk },
		{ SCAMENUTYPE_Command, 2, (IPTR) "unsnapshot", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_Popup_Disk },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_PASTE, MSGID_DEFAULT_MENU_PASTE_SHORT, DEFAULTPARENTNODE_Popup_Disk },
		{ SCAMENUTYPE_Command, 2, (IPTR) "paste", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_Popup_Disk },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_DISKCOPY, MSGID_DEFAULT_MENU_DISKCOPY_SHORT, DEFAULTPARENTNODE_Popup_Disk },
		{ SCAMENUTYPE_Command, 2, (IPTR) "sys:system/diskcopy", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_RELABEL, MSGID_DEFAULT_MENU_RELABEL_SHORT, DEFAULTPARENTNODE_Popup_Disk },
		{ SCAMENUTYPE_Command, 2, (IPTR) "rename", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_Popup_Disk },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_FORMAT, MSGID_DEFAULT_MENU_FORMAT_SHORT, DEFAULTPARENTNODE_Popup_Disk },
		{ SCAMENUTYPE_Command, 2, (IPTR) "formatdisk", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_Popup_Disk },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_PROPERTIES, MSGID_DEFAULT_MENU_PROPERTIES_SHORT, DEFAULTPARENTNODE_Popup_Disk },
		{ SCAMENUTYPE_Command, 2, (IPTR) "iconproperties", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },

	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_OPEN, MSGID_DEFAULT_MENU_OPEN_SHORT, DEFAULTPARENTNODE_Popup_Drawer },
		{ SCAMENUTYPE_Command, 2, (IPTR) "open", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_INFORMATION, MSGID_DEFAULT_MENU_INFORMATION_SHORT, DEFAULTPARENTNODE_Popup_Drawer },
		{ SCAMENUTYPE_Command, 2, (IPTR) "iconinfo", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_Popup_Drawer },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_BROWSE, MSGID_DEFAULT_MENU_BROWSE_SHORT, DEFAULTPARENTNODE_Popup_Drawer },
		{ SCAMENUTYPE_Command, 2, (IPTR) "Scalos:Tools/browse.script %%p", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_AmigaDOS, 0, MCOMFLGF_Args, DEFAULT_STACKSIZE },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_FIND, MSGID_DEFAULT_MENU_FIND_SHORT, DEFAULTPARENTNODE_Popup_Drawer },
		{ SCAMENUTYPE_Command, 2, (IPTR) "System:System/Find", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, MCOMFLGF_Args, DEFAULT_STACKSIZE },
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_Popup_Drawer },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_SNAPSHOT, MSGID_DEFAULT_MENU_SNAPSHOT_SHORT, DEFAULTPARENTNODE_Popup_Drawer },
		{ SCAMENUTYPE_Command, 2, (IPTR) "snapshot", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_UNSNAPSHOT, MSGID_DEFAULT_MENU_UNSNAPSHOT_SHORT, DEFAULTPARENTNODE_Popup_Drawer },
		{ SCAMENUTYPE_Command, 2, (IPTR) "unsnapshot", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_Popup_Drawer },
	{ SCAMENUTYPE_Menu, 1, MSGID_DEFAULT_MENU_EDIT, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_Popup_Drawer },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_CUT, MSGID_DEFAULT_MENU_CUT_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "cut", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_COPY, MSGID_DEFAULT_MENU_COPY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "copy", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PASTE, MSGID_DEFAULT_MENU_PASTE_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "paste", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_RENAME, MSGID_DEFAULT_MENU_RENAME_SHORT, DEFAULTPARENTNODE_Popup_Drawer },
		{ SCAMENUTYPE_Command, 2, (IPTR) "rename", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_LEAVEOUT, MSGID_DEFAULT_MENU_LEAVEOUT_SHORT, DEFAULTPARENTNODE_Popup_Drawer },
		{ SCAMENUTYPE_Command, 2, (IPTR) "leaveout", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_PUTAWAY, MSGID_DEFAULT_MENU_PUTAWAY_SHORT, DEFAULTPARENTNODE_Popup_Drawer },
		{ SCAMENUTYPE_Command, 2, (IPTR) "putaway", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_DELETE, MSGID_DEFAULT_MENU_DELETE_SHORT, DEFAULTPARENTNODE_Popup_Drawer },
		{ SCAMENUTYPE_Command, 2, (IPTR) "delete", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_Popup_Drawer },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_PROPERTIES, MSGID_DEFAULT_MENU_PROPERTIES_SHORT, DEFAULTPARENTNODE_Popup_Drawer },
		{ SCAMENUTYPE_Command, 2, (IPTR) "iconproperties", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },

	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_OPEN, MSGID_DEFAULT_MENU_OPEN_SHORT, DEFAULTPARENTNODE_Popup_ToolProject },
		{ SCAMENUTYPE_Command, 2, (IPTR) "open", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_INFORMATION, MSGID_DEFAULT_MENU_INFORMATION_SHORT, DEFAULTPARENTNODE_Popup_ToolProject },
		{ SCAMENUTYPE_Command, 2, (IPTR) "iconinfo", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_Popup_ToolProject },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_SNAPSHOT, MSGID_DEFAULT_MENU_SNAPSHOT_SHORT, DEFAULTPARENTNODE_Popup_ToolProject },
		{ SCAMENUTYPE_Command, 2, (IPTR) "snapshot", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_UNSNAPSHOT, MSGID_DEFAULT_MENU_UNSNAPSHOT_SHORT, DEFAULTPARENTNODE_Popup_ToolProject },
		{ SCAMENUTYPE_Command, 2, (IPTR) "unsnapshot", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_Popup_ToolProject },
	{ SCAMENUTYPE_Menu, 1, MSGID_DEFAULT_MENU_EDIT, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_Popup_ToolProject },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_CUT, MSGID_DEFAULT_MENU_CUT_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "cut", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_COPY, MSGID_DEFAULT_MENU_COPY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "copy", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PASTE, MSGID_DEFAULT_MENU_PASTE_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "paste", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_RENAME, MSGID_DEFAULT_MENU_RENAME_SHORT, DEFAULTPARENTNODE_Popup_ToolProject },
		{ SCAMENUTYPE_Command, 2, (IPTR) "rename", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_LEAVEOUT, MSGID_DEFAULT_MENU_LEAVEOUT_SHORT, DEFAULTPARENTNODE_Popup_ToolProject },
		{ SCAMENUTYPE_Command, 2, (IPTR) "leaveout", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_PUTAWAY, MSGID_DEFAULT_MENU_PUTAWAY_SHORT, DEFAULTPARENTNODE_Popup_ToolProject },
		{ SCAMENUTYPE_Command, 2, (IPTR) "putaway", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_DELETE, MSGID_DEFAULT_MENU_DELETE_SHORT, DEFAULTPARENTNODE_Popup_ToolProject },
		{ SCAMENUTYPE_Command, 2, (IPTR) "delete", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_Popup_ToolProject },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_PROPERTIES, MSGID_DEFAULT_MENU_PROPERTIES_SHORT, DEFAULTPARENTNODE_Popup_ToolProject },
		{ SCAMENUTYPE_Command, 2, (IPTR) "iconproperties", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },

	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_OPEN, MSGID_DEFAULT_MENU_OPEN_SHORT, DEFAULTPARENTNODE_Popup_Trashcan },
		{ SCAMENUTYPE_Command, 2, (IPTR) "open", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_INFORMATION, MSGID_DEFAULT_MENU_INFORMATION_SHORT, DEFAULTPARENTNODE_Popup_Trashcan },
		{ SCAMENUTYPE_Command, 2, (IPTR) "iconinfo", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_Popup_Trashcan },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_EMPTYTRASH, MSGID_DEFAULT_MENU_EMPTYTRASH_SHORT, DEFAULTPARENTNODE_Popup_Trashcan },
		{ SCAMENUTYPE_Command, 2, (IPTR) "emptytrashcan", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_Popup_Trashcan },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_SNAPSHOT, MSGID_DEFAULT_MENU_SNAPSHOT_SHORT, DEFAULTPARENTNODE_Popup_Trashcan },
		{ SCAMENUTYPE_Command, 2, (IPTR) "snapshot", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_UNSNAPSHOT, MSGID_DEFAULT_MENU_UNSNAPSHOT_SHORT, DEFAULTPARENTNODE_Popup_Trashcan },
		{ SCAMENUTYPE_Command, 2, (IPTR) "unsnapshot", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_Popup_Trashcan },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_PROPERTIES, MSGID_DEFAULT_MENU_PROPERTIES_SHORT, DEFAULTPARENTNODE_Popup_Trashcan },
		{ SCAMENUTYPE_Command, 2, (IPTR) "iconproperties", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },

	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_CLOSE, MSGID_DEFAULT_MENU_CLOSE_SHORT, DEFAULTPARENTNODE_Popup_Window },
		{ SCAMENUTYPE_Command, 2, (IPTR) "close", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_OPENPARENT, MSGID_DEFAULT_MENU_OPENPARENT_SHORT, DEFAULTPARENTNODE_Popup_Window },
		{ SCAMENUTYPE_Command, 2, (IPTR) "parent", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_Popup_Window },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_BROWSE, MSGID_DEFAULT_MENU_BROWSE_SHORT, DEFAULTPARENTNODE_Popup_Window },
		{ SCAMENUTYPE_Command, 2, (IPTR) "Scalos:Tools/browse.script %%p", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_AmigaDOS, 0, MCOMFLGF_Args, DEFAULT_STACKSIZE },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_FIND, MSGID_DEFAULT_MENU_FIND_SHORT, DEFAULTPARENTNODE_Popup_Window },
		{ SCAMENUTYPE_Command, 2, (IPTR) "System:System/Find", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, MCOMFLGF_Args, DEFAULT_STACKSIZE },
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_Popup_Window },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_PASTE, MSGID_DEFAULT_MENU_PASTE_SHORT, DEFAULTPARENTNODE_Popup_Window },
		{ SCAMENUTYPE_Command, 2, (IPTR) "paste", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_Popup_Window },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_UPDATE, MSGID_DEFAULT_MENU_UPDATE_SHORT, DEFAULTPARENTNODE_Popup_Window },
		{ SCAMENUTYPE_Command, 2, (IPTR) "update", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_CLEANUP, MSGID_DEFAULT_MENU_CLEANUP_SHORT, DEFAULTPARENTNODE_Popup_Window },
		{ SCAMENUTYPE_Command, 2, (IPTR) "Scalos:Plugins/Menu/sorted_cleanup.plugin", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Plugin },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_RESIZETOFIT, MSGID_DEFAULT_MENU_RESIZETOFIT_SHORT, DEFAULTPARENTNODE_Popup_Window },
		{ SCAMENUTYPE_Command, 2, (IPTR) "sizetofit", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_Popup_Window },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_SELECTCONTENTS, MSGID_DEFAULT_MENU_SELECTCONTENTS_SHORT, DEFAULTPARENTNODE_Popup_Window },
		{ SCAMENUTYPE_Command, 2, (IPTR) "selectall", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_CLEARSELECTION, MSGID_DEFAULT_MENU_CLEARSELECTION_SHORT, DEFAULTPARENTNODE_Popup_Window },
		{ SCAMENUTYPE_Command, 2, (IPTR) "clearselection", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_Popup_Window },
	{ SCAMENUTYPE_Menu, 1, MSGID_DEFAULT_MENU_SNAPSHOT, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_Popup_Window },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_SNAPSHOT_WINDOW, MSGID_DEFAULT_MENU_SNAPSHOT_WINDOW_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "snapshotwindow", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_SNAPSHOT_ALL, MSGID_DEFAULT_MENU_SNAPSHOT_ALL_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "snapshotall", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_Popup_Window },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_NEWDRAWER, MSGID_DEFAULT_MENU_NEWDRAWER_SHORT, DEFAULTPARENTNODE_Popup_Window },
		{ SCAMENUTYPE_Command, 2, (IPTR) "makedir", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_Popup_Window },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_PROPERTIES, MSGID_DEFAULT_MENU_PROPERTIES_SHORT, DEFAULTPARENTNODE_Popup_Window },
		{ SCAMENUTYPE_Command, 2, (IPTR) "windowproperties", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },

	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_OPEN, MSGID_DEFAULT_MENU_OPEN_SHORT, DEFAULTPARENTNODE_Popup_AppIcon },
		{ SCAMENUTYPE_Command, 2, (IPTR) "open", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_INFORMATION, MSGID_DEFAULT_MENU_INFORMATION_SHORT, DEFAULTPARENTNODE_Popup_AppIcon },
		{ SCAMENUTYPE_Command, 2, (IPTR) "iconinfo", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_CLONE, MSGID_DEFAULT_MENU_CLONE_SHORT, DEFAULTPARENTNODE_Popup_AppIcon },
		{ SCAMENUTYPE_Command, 2, (IPTR) "clone", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_RENAME, MSGID_DEFAULT_MENU_RENAME_SHORT, DEFAULTPARENTNODE_Popup_AppIcon },
		{ SCAMENUTYPE_Command, 2, (IPTR) "rename", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_Popup_AppIcon },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_SNAPSHOT, MSGID_DEFAULT_MENU_SNAPSHOT_SHORT, DEFAULTPARENTNODE_Popup_AppIcon },
		{ SCAMENUTYPE_Command, 2, (IPTR) "snapshot", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_UNSNAPSHOT, MSGID_DEFAULT_MENU_UNSNAPSHOT_SHORT, DEFAULTPARENTNODE_Popup_AppIcon },
		{ SCAMENUTYPE_Command, 2, (IPTR) "unsnapshot", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_Popup_AppIcon },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_LEAVEOUT, MSGID_DEFAULT_MENU_LEAVEOUT_SHORT, DEFAULTPARENTNODE_Popup_AppIcon },
		{ SCAMENUTYPE_Command, 2, (IPTR) "leaveout", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_PUTAWAY, MSGID_DEFAULT_MENU_PUTAWAY_SHORT, DEFAULTPARENTNODE_Popup_AppIcon },
		{ SCAMENUTYPE_Command, 2, (IPTR) "putaway", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_Popup_AppIcon },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_DELETE, MSGID_DEFAULT_MENU_DELETE_SHORT, DEFAULTPARENTNODE_Popup_AppIcon },
		{ SCAMENUTYPE_Command, 2, (IPTR) "delete", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_FORMAT, MSGID_DEFAULT_MENU_FORMAT_SHORT, DEFAULTPARENTNODE_Popup_AppIcon },
		{ SCAMENUTYPE_Command, 2, (IPTR) "formatdisk", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_EMPTYTRASH, MSGID_DEFAULT_MENU_EMPTYTRASH_SHORT, DEFAULTPARENTNODE_Popup_AppIcon },
		{ SCAMENUTYPE_Command, 2, (IPTR) "emptytrashcan", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },

	// Desktop popup
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_EXECUTECOMMAND, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_Popup_Desktop },
		{ SCAMENUTYPE_Command, 2, (IPTR) "executecommand", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_BROWSE, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_Popup_Desktop },
		{ SCAMENUTYPE_Command, 2, (IPTR) "Scalos:Tools/browse.script %%p", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_AmigaDOS, 0, MCOMFLGF_Args, DEFAULT_STACKSIZE },
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_Popup_Desktop },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_COM_UNDO, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_Popup_Desktop },
		{ SCAMENUTYPE_Command, 2, (IPTR) "undo", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_COM_REDO, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_Popup_Desktop },
		{ SCAMENUTYPE_Command, 2, (IPTR) "redo", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_Popup_Desktop },
#if defined(__MORPHOS__)
	{ SCAMENUTYPE_Menu, 1, MSGID_DEFAULT_TOOLS, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_Popup_Desktop },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_TOOLS_MOUNTER, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Tools/Mounter", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_TOOLS_SCSICONFIG, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Tools/SCSIConfig", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_TOOLS_SNOOPIUM, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Tools/Snoopium", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_TOOLS_DEFRAG, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Tools/Defrag", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_TOOLS_FTMANAGER, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Tools/FTManager", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_TOOLS_MUISHELL, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Tools/MUIShell", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_TOOLS_SFSDOCTOR, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Tools/SFSDoctor", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_TOOLS_UNITCONTROL, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Tools/UnitControl", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_TOOLS_FILEIMAGECTRL, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Tools/FileImageCtrl", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_TOOLS_HDCONFIG, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Tools/HDConfig", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_TOOLS_REGTOOL, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Tools/RegTool", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_TOOLS_SHELL, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Tools/Shell", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
	{ SCAMENUTYPE_Menu, 1, MSGID_DEFAULT_UTILITIES, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_Popup_Desktop },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_EDITOR, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/Editor", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_FRAGMENT, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/Fragment", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_GRABBER, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/Grabber", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_GRAPHICBOARDS, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/GraphicBoards", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_KEYSTROKE, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/Keystroke", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_MINICALC, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/MiniCalc", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_MORE, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/More", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_MUIPROCALC, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/MUIProCalc", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_MULTIVIEW, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/Multiview", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_MYSTICVIEW, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/Mysticview", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_TASKMANAGER, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/TaskManager", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_TRANCESTATS, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/Trancestats", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_TIPS, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/Tips", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_ZOOM, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/Zoom", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
	{ SCAMENUTYPE_Menu, 1, MSGID_DEFAULT_PREFERENCES, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_Popup_Desktop },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_SYSTEM, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "MOSSYS:Prefs/Preferences", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_MUI, MSGID_DEFAULT_MENU_PREFS_MUI_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "MOSSYS:Prefs/MUI", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
#elif defined(__amigaos4__)
	{ SCAMENUTYPE_Menu, 1, MSGID_DEFAULT_SYSTEM, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_Popup_Desktop },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_SYSTEM_FIND, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:System/Find", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_SYSTEM_FIXFONT, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:System/FixFonts", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_SYSTEM_FORMAT, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:System/Format", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_SYSTEM_FORMATCDRW, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:System/FormatCDRW", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_SYSTEM_MEDIATOOLBOX, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:System/Media Toolbox", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_SYSTEM_MOUNTER, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:System/Mounter", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_SYSTEM_TYPEMANAGER, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:System/TypeManager", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_SYSTEM_SHELL, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:System/Shell", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_SYSTEM_HELP, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:System/Help", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
	{ SCAMENUTYPE_Menu, 1, MSGID_DEFAULT_UTILITIES, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_Popup_Desktop },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_AMIGS, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/AmiGS/AmiGS", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_AMIPDF, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/AmiPDF/AmiPDF", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_SGRAB, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/SGrab/SGrab", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_LastInsertedMenuItem },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_CALCULATOR, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/Calculator", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_CLOCK, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/Clock", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_GRAPHICDUMP, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/GraphicDump", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_ICONEDIT, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/IconEdit", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_INITPRINTER, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/InitPrinter", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_KEYSHOW, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/KeyShow", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_MEMACS, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/Memacs", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_MULTIVIEW, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/Multiview", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_NOTEPAD, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/NotePad", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_PARTITIONWIZARD, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/PartitionWizard", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_PLAYCD, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/PlayCD", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_PREFSOBJECTSEDITOR, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/PrefsObjectsEditor", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_PRINTFILES, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/PrintFiles", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_RAWDISK, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/RawDisk", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_SHOWCONFIG, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/ShowConfig", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_UNARC, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/UnArc", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_USBINSPECTOR, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/USBInspector", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
	{ SCAMENUTYPE_Menu, 1, MSGID_DEFAULT_PREFERENCES, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_Popup_Desktop },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_AHI, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/AHI", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_AMIGAINPUT, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/AmigaInput", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_ASL, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/ASL", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_COMPATIBILITY, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/Compatibility", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_DEFICONS, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/DefIcons", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_DOS, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/DOS", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_FONT, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/Font", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_GUI, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/GUI", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_INPUT, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/Input", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_INTERNET, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/Internet", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_LOCALE, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/Locale", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_NOTIFICATIONS, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/Notifications", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_PALETTE, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/Palette", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_PICASSO96MODE, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/Picasso96Mode", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_POINTER, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/Pointer", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_POPUPMENU, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/PopupMenu", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_PRINTER, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/Printer", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_PRINTERGFX, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/PrinterGFX", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_PRINTERPS, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/PrinterPS", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_SCREENBLANKER, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/ScreenBlanker", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_SCREENMODE, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/ScreenMode", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_SCREENS, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/Screens", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_SERIAL, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/Serial", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_SOUND, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/Sound", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_TIME, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/Time", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_URL, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/URL", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_USB, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/USB", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_WBPATTERN, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/WBPattern", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_WBSTARTUP, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/WBStartup", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_WORKBENCH, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/Workbench", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
#else
	{ SCAMENUTYPE_Menu, 1, MSGID_DEFAULT_SYSTEM, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_Popup_Desktop },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_SYSTEM_FIND, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:System/Find", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_SYSTEM_FIXFONT, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:System/FixFonts", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_SYSTEM_FORMAT, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:System/Format", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_SYSTEM_INTELLIFONT, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:System/Intellifont", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_SYSTEM_SHELL, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:System/Shell", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },

	{ SCAMENUTYPE_Menu, 1, MSGID_DEFAULT_TOOLS, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_Popup_Desktop },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_TOOLS_BENCHTRASH, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/BenchTrash", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_TOOLS_CALCULATOR, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Tools/Calculator", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_TOOLS_EDITPAD, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/EditPad", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_TOOLS_GRAPHICDUMP, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Tools/GraphicDump", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_TOOLS_HDTOOLBOX, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Tools/HDToolBox", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_TOOLS_ICONEDIT, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/IconEdit", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_TOOLS_INITPRINTER, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/InitPrinter", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_TOOLS_IOTOOLS, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/IoTools", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_TOOLS_KEYSHOW, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/KeyShow", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_TOOLS_LACER, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/Lacer", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_TOOLS_MEMACS, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/Memacs", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_TOOLS_MOUNTER, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Tools/Mounter", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_TOOLS_PREPCARD, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Tools/PrepCard", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_TOOLS_PRINTFILES, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/PrintFiles", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_TOOLS_SHOWCONFIG, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/ShowConfig", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_TOOLS_UNARC, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/UnArc", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
	
	{ SCAMENUTYPE_Menu, 1, MSGID_DEFAULT_UTILITIES, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_Popup_Desktop },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_CLOCK, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/Clock", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_MULTIVIEW, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/Multiview", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_PLAYCD, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/PlayCD", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_UTILITIES_WBCLOCK, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Utilities/WBClock", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
	{ SCAMENUTYPE_Menu, 1, MSGID_DEFAULT_PREFERENCES, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_Popup_Desktop },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_AHI, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/AHI", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_ASL, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/ASL", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_CACHECDFS, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/CacheCDFS", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_DEFICONS, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/DefIcons", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_FONT, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/Font", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_ICONTROL, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/IControl", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_INPUT, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/Input", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_LOCALE, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/Locale", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_OVERSCAN, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/Overscan", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_PALETTE, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/Palette", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_POINTER, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/Pointer", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_PRINTER, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/Printer", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_PRINTERGFX, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/PrinterGFX", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_PRINTERPS, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/PrinterPS", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_REACTION, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/Reaction", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_SCREENMODE, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/ScreenMode", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_SERIAL, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/Serial", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_SOUND, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/Sound", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_TIME, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/Time", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_VINCED, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/ViNCDd", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_WARPOS, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/WarpOS", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_WBPATTERN, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/WBPattern", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
		{ SCAMENUTYPE_MenuItem, 2, MSGID_DEFAULT_MENU_PREFS_WORKBENCH, MSGID_DEFAULT_MENU_PREFS_SYSTEM_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem },
			{ SCAMENUTYPE_Command, 3, (IPTR) "SYS:Prefs/Workbench", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
#endif
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_Popup_Desktop },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_EXCHANGE, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_Popup_Desktop },
		{ SCAMENUTYPE_Command, 2, (IPTR) "Scalos:Modules/Exchange.module", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Workbench, 0, 0, DEFAULT_STACKSIZE },
	{ SCAMENUTYPE_MenuItem, 1, 0, MSGID_MENU_SEPARATOR, DEFAULTPARENTNODE_Popup_Desktop },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_REDRAWALL, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_Popup_Desktop },
		{ SCAMENUTYPE_Command, 2, (IPTR) "redrawall", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_UPDATEALL, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_Popup_Desktop },
		{ SCAMENUTYPE_Command, 2, (IPTR) "updateall", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_LASTMESSAGE, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_Popup_Desktop },
		{ SCAMENUTYPE_Command, 2, (IPTR) "lastmsg", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	{ SCAMENUTYPE_MenuItem, 1, MSGID_DEFAULT_MENU_OPEN, MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_Popup_Desktop },
		{ SCAMENUTYPE_Command, 2, (IPTR) "about", MSGID_DEFAULT_MENU_EMPTY_SHORT, DEFAULTPARENTNODE_LastInsertedMenuItem, SCAMENUCMDTYPE_Command },
	};

const ULONG DefaultMenuEntries = Sizeof(DefaultMenu);

