/***************************************************************************

 Mailtext - An MUI Custom Class for eMessage display
 Copyright (C) 1996-2001 by Olaf Peters
 Copyright (C) 2002-2006 by Mailtext Open Source Team

 GCC & OS4 Portage by Alexandre Balaban

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 Mailtext OpenSource project :  http://sourceforge.net/projects/mailtext/

 $Id$

 PrefsImage to display in MUI prefs for Mailtext.

***************************************************************************/

#ifdef USE_PREFSIMAGE_COLORS
const ULONG PrefsImage_colors[24] =
{
	0xffffffff,0xffffffff,0x99999999,
	0x00000000,0x00000000,0x00000000,
	0xf0f0f0f0,0xf0f0f0f0,0xf0f0f0f0,
	0xbabababa,0x55555555,0x8a8a8a8a,
	0x99999999,0x90909090,0x99999999,
	0xbbbbbbbb,0xb0b0b0b0,0xbbbbbbbb,
	0xaaaaaaaa,0xa0a0a0a0,0xaaaaaaaa,
	0xffffffff,0xbbbbbbbb,0xaaaaaaaa,
};
#endif

#define PREFSIMAGE_WIDTH        23
#define PREFSIMAGE_HEIGHT       14
#define PREFSIMAGE_DEPTH         3
#define PREFSIMAGE_COMPRESSION   1
#define PREFSIMAGE_MASKING       0

#ifdef USE_PREFSIMAGE_HEADER
const struct BitMapHeader PrefsImage_header =
{ 23,14,0,0,3,0,1,0,0,1,1,23,14 };
#endif

#ifdef USE_PREFSIMAGE_BODY
const UBYTE PrefsImage_body[210] = {
0x03,0x24,0x70,0x00,0x00,0x03,0x1b,0x90,0x00,0x00,0x03,0x00,0x40,0x00,0x00,
0x03,0x4d,0x1c,0x00,0x00,0x03,0x36,0xe4,0x00,0x00,0x03,0x00,0x10,0x00,0x00,
0x03,0x96,0x47,0x00,0x00,0x03,0x6d,0xb9,0x00,0x00,0x03,0x00,0x24,0x00,0x00,
0x03,0x24,0x91,0xc0,0x00,0x03,0xdb,0x6e,0x40,0x00,0x03,0x00,0x21,0x00,0x00,
0x03,0x09,0xc8,0x70,0x00,0x03,0xf6,0x37,0x90,0x00,0x03,0x00,0x80,0x40,0x00,
0x03,0xc3,0x11,0x1c,0x00,0x03,0x3d,0xea,0xe4,0x00,0x03,0xc0,0x05,0x10,0x00,
0x03,0xb1,0xa5,0x46,0x00,0x03,0x0e,0x5e,0x98,0x00,0x03,0xf1,0x08,0x24,0x00,
0x03,0x2c,0x3a,0x90,0x00,0x03,0xd3,0xe5,0x6e,0x00,0x03,0x2c,0x00,0x20,0x00,
0x03,0x92,0x0c,0xc2,0x00,0x03,0x25,0xfb,0x3c,0x00,0x03,0xda,0x00,0x80,0x00,
0x03,0x84,0x62,0x46,0x00,0x03,0x6b,0xdc,0xb8,0x00,0x03,0x94,0x21,0x02,0x00,
0x03,0x68,0xf8,0x8e,0x00,0x03,0x97,0xd7,0x70,0x00,0x03,0x68,0x69,0x04,0x00,
0x03,0x91,0xce,0x1e,0x00,0x03,0x2f,0x75,0xe0,0x00,0x03,0xd0,0xca,0x0a,0x00,
0x03,0x23,0xf6,0x3e,0x00,0x03,0xde,0xbd,0xc2,0x00,0x03,0x21,0xb4,0x14,0x00,
0x03,0x84,0x3c,0x7e,0x00,0x03,0x7c,0x53,0x84,0x00,0x03,0x83,0xb8,0x28,0x00,
 };
#endif
