/***************************************************************************

 TheBar.mcc - Next Generation Toolbar MUI Custom Class
 Copyright (C) 2003-2005 Alfonso Ranieri
 Copyright (C) 2005-2022 TheBar Open Source Team

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 TheBar class Support Site:  http://www.sf.net/projects/thebar

 $Id$

***************************************************************************/

#include <stdint.h>

#if !defined(__MORPHOS__)
#if defined(__AROS__)
const uint8_t icon32[] =
{
	0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff,
	0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff,
	0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x0b, 0x00, 0x00, 0x00, 0xc7, 0xff, 0xfe, 0xff, 0xc8, 0xfb, 0xfa, 0xfb, 0xc8, 0xf8, 0xf7, 0xf8,
	0xc8, 0xf4, 0xf3, 0xf4, 0xc8, 0xf1, 0xf0, 0xf1, 0xc8, 0xee, 0xed, 0xee, 0xc8, 0xeb, 0xea, 0xeb, 0xc8, 0xe7, 0xe6, 0xe7, 0xc8, 0xe5, 0xe4, 0xe5, 0xc8, 0xe6, 0xe5, 0xe6, 0xc8, 0xea, 0xe9, 0xea, 0xc8, 0xed, 0xec, 0xed, 0xc8, 0xf1, 0xf0, 0xf1,
	0xc8, 0xf4, 0xf3, 0xf4, 0xc8, 0xf7, 0xf6, 0xf7, 0xc8, 0xf9, 0xf8, 0xf9, 0xc8, 0xfd, 0xfc, 0xfd, 0xc7, 0xff, 0xff, 0xff, 0x0b, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff,
	0x16, 0x00, 0x00, 0x00, 0xc6, 0xfe, 0xfd, 0xfe, 0xb2, 0xfd, 0xfc, 0xfd, 0xaf, 0xf8, 0xf7, 0xf8, 0xb0, 0xf1, 0xf0, 0xf1, 0xb0, 0xed, 0xec, 0xed, 0xb0, 0xe7, 0xe6, 0xe7, 0xb0, 0xe2, 0xe1, 0xe2, 0xb0, 0xdd, 0xdc, 0xdd, 0xb0, 0xd7, 0xd6, 0xd7,
	0xb0, 0xd2, 0xd1, 0xd2, 0xb0, 0xd5, 0xd4, 0xd5, 0xb0, 0xdb, 0xda, 0xdb, 0xb0, 0xe1, 0xe0, 0xe1, 0xb0, 0xe6, 0xe5, 0xe6, 0xb0, 0xeb, 0xea, 0xeb, 0xb0, 0xf1, 0xf0, 0xf1, 0xb4, 0xf7, 0xf6, 0xf7, 0xc7, 0xfd, 0xfc, 0xfd, 0x16, 0x00, 0x00, 0x00,
	0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x20, 0x00, 0x00, 0x00, 0xc5, 0xfc, 0xfb, 0xfc, 0xac, 0xfd, 0xfc, 0xfd, 0xaa, 0xfc, 0xfb, 0xfc, 0xaa, 0xf6, 0xf5, 0xf6, 0xaa, 0xef, 0xee, 0xef,
	0xbf, 0xe9, 0xe8, 0xe9, 0xe1, 0xec, 0xeb, 0xec, 0xf1, 0xf3, 0xf2, 0xf3, 0xf5, 0xf8, 0xf7, 0xf8, 0xf5, 0xfc, 0xfb, 0xfc, 0xf1, 0xf6, 0xf5, 0xf6, 0xe1, 0xec, 0xeb, 0xec, 0xbf, 0xdf, 0xde, 0xdf, 0xaa, 0xdd, 0xdc, 0xdd, 0xaa, 0xe3, 0xe2, 0xe3,
	0xa9, 0xe9, 0xe8, 0xe9, 0xaf, 0xf1, 0xf0, 0xf1, 0xc6, 0xf9, 0xf8, 0xf9, 0x20, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x20, 0x00, 0x00, 0x00, 0xc4, 0xf7, 0xf6, 0xf7,
	0xad, 0xf8, 0xf7, 0xf8, 0xab, 0xfd, 0xfc, 0xfd, 0xab, 0xfc, 0xfb, 0xfc, 0xd3, 0xea, 0xe9, 0xea, 0xfd, 0xe7, 0xe6, 0xe6, 0xff, 0xe3, 0xc4, 0xc4, 0xff, 0xe1, 0xa5, 0xa5, 0xff, 0xe8, 0xa2, 0xa2, 0xff, 0xe8, 0xa3, 0xa3, 0xff, 0xea, 0xad, 0xad,
	0xff, 0xea, 0xcc, 0xcc, 0xfd, 0xec, 0xeb, 0xeb, 0xd3, 0xe0, 0xdf, 0xe0, 0xab, 0xdd, 0xdc, 0xdd, 0xaa, 0xe3, 0xe2, 0xe3, 0xb0, 0xec, 0xeb, 0xec, 0xc5, 0xf6, 0xf5, 0xf6, 0x20, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff,
	0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x20, 0x00, 0x00, 0x00, 0xc4, 0xf3, 0xf2, 0xf3, 0xad, 0xf2, 0xf1, 0xf2, 0xab, 0xf8, 0xf7, 0xf8, 0xd3, 0xe5, 0xe4, 0xe5, 0xff, 0xdc, 0xdb, 0xdb, 0xff, 0xce, 0x89, 0x89, 0xff, 0xac, 0x52, 0x52,
	0xff, 0x96, 0x3b, 0x3b, 0xff, 0x90, 0x36, 0x36, 0xff, 0x91, 0x36, 0x36, 0xff, 0x98, 0x3d, 0x3d, 0xff, 0xb7, 0x5c, 0x5c, 0xff, 0xd9, 0x94, 0x94, 0xff, 0xe4, 0xe3, 0xe3, 0xd3, 0xdb, 0xda, 0xdb, 0xaa, 0xdd, 0xdc, 0xdd, 0xb0, 0xe6, 0xe5, 0xe6,
	0xc5, 0xf3, 0xf2, 0xf3, 0x20, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x20, 0x00, 0x00, 0x00, 0xc3, 0xef, 0xee, 0xef, 0xad, 0xec, 0xeb, 0xec, 0xbf, 0xe3, 0xe2, 0xe3,
	0xfd, 0xcf, 0xce, 0xce, 0xff, 0xc1, 0x7c, 0x7c, 0xff, 0xa8, 0x4e, 0x4e, 0xff, 0x89, 0x2f, 0x2f, 0xff, 0x95, 0x3b, 0x3b, 0xff, 0x95, 0x3b, 0x3b, 0xff, 0x95, 0x3b, 0x3b, 0xff, 0x95, 0x3b, 0x3b, 0xff, 0x95, 0x3b, 0x3b, 0xff, 0xb2, 0x57, 0x57,
	0xff, 0xcd, 0x88, 0x88, 0xfd, 0xd5, 0xd4, 0xd4, 0xbf, 0xd4, 0xd3, 0xd4, 0xb0, 0xe0, 0xdf, 0xe0, 0xc4, 0xef, 0xee, 0xef, 0x20, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff,
	0x20, 0x00, 0x00, 0x00, 0xc2, 0xeb, 0xea, 0xeb, 0xad, 0xe6, 0xe5, 0xe6, 0xe1, 0xca, 0xca, 0xca, 0xff, 0xbe, 0xa0, 0xa0, 0xff, 0xa1, 0x47, 0x47, 0xff, 0x8f, 0x35, 0x35, 0xff, 0x9b, 0x41, 0x41, 0xff, 0xa1, 0x47, 0x47, 0xff, 0xa6, 0x4c, 0x4c,
	0xff, 0xa6, 0x4c, 0x4c, 0xff, 0xa6, 0x4c, 0x4c, 0xff, 0xa1, 0x47, 0x47, 0xff, 0x9b, 0x41, 0x41, 0xff, 0xad, 0x53, 0x53, 0xff, 0xc8, 0xaa, 0xaa, 0xe1, 0xca, 0xca, 0xca, 0xaf, 0xda, 0xd9, 0xda, 0xc3, 0xeb, 0xea, 0xeb, 0x20, 0x00, 0x00, 0x00,
	0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x1f, 0x00, 0x00, 0x00, 0xc1, 0xe8, 0xe7, 0xe8, 0xad, 0xe0, 0xdf, 0xe0, 0xf1, 0xbe, 0xbe, 0xbe, 0xff, 0xb1, 0x75, 0x75, 0xff, 0x97, 0x3d, 0x3d,
	0xff, 0xa1, 0x47, 0x47, 0xff, 0xa6, 0x4c, 0x4c, 0xff, 0xb2, 0x58, 0x58, 0xff, 0xb8, 0x5e, 0x5e, 0xff, 0xb8, 0x5e, 0x5e, 0xff, 0xb8, 0x5e, 0x5e, 0xff, 0xb2, 0x58, 0x58, 0xff, 0xa6, 0x4c, 0x4c, 0xff, 0xa8, 0x4e, 0x4e, 0xff, 0xbd, 0x81, 0x81,
	0xf1, 0xc2, 0xc2, 0xc2, 0xaf, 0xd4, 0xd3, 0xd4, 0xc2, 0xe5, 0xe4, 0xe5, 0x20, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x1f, 0x00, 0x00, 0x00, 0xc0, 0xe4, 0xe3, 0xe4,
	0xad, 0xdc, 0xdb, 0xdc, 0xf5, 0xb6, 0xb6, 0xb6, 0xff, 0xab, 0x66, 0x66, 0xff, 0x9e, 0x43, 0x43, 0xff, 0xa6, 0x4c, 0x4c, 0xff, 0xb8, 0x5e, 0x5e, 0xff, 0xc4, 0x6a, 0x6a, 0xff, 0xca, 0x70, 0x70, 0xff, 0xca, 0x70, 0x70, 0xff, 0xca, 0x70, 0x70,
	0xff, 0xc4, 0x6a, 0x6a, 0xff, 0xb8, 0x5e, 0x5e, 0xff, 0xa9, 0x4e, 0x4e, 0xff, 0xb4, 0x6f, 0x6f, 0xf5, 0xbc, 0xbc, 0xbc, 0xaf, 0xd2, 0xd1, 0xd2, 0xc1, 0xe2, 0xe1, 0xe2, 0x1f, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff,
	0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x1f, 0x00, 0x00, 0x00, 0xbf, 0xde, 0xdd, 0xde, 0xad, 0xd7, 0xd6, 0xd7, 0xf5, 0xaf, 0xaf, 0xaf, 0xff, 0xa4, 0x5f, 0x5f, 0xff, 0xa2, 0x48, 0x48, 0xff, 0xb2, 0x58, 0x58, 0xff, 0xc4, 0x6a, 0x6a,
	0xff, 0xd0, 0x76, 0x76, 0xff, 0xdc, 0x82, 0x82, 0xff, 0xdc, 0x82, 0x82, 0xff, 0xdc, 0x82, 0x82, 0xff, 0xd0, 0x76, 0x76, 0xff, 0xc4, 0x6a, 0x6a, 0xff, 0xb2, 0x58, 0x58, 0xff, 0xad, 0x68, 0x68, 0xf5, 0xb5, 0xb5, 0xb5, 0xaf, 0xd5, 0xd4, 0xd5,
	0xc0, 0xde, 0xdd, 0xde, 0x1f, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x1f, 0x00, 0x00, 0x00, 0xbe, 0xdf, 0xde, 0xdf, 0xad, 0xcd, 0xcc, 0xcd, 0xf1, 0xa7, 0xa7, 0xa7,
	0xff, 0x9c, 0x5f, 0x5f, 0xff, 0xa5, 0x4a, 0x4a, 0xff, 0xb8, 0x5e, 0x5e, 0xff, 0xca, 0x70, 0x70, 0xff, 0xdc, 0x82, 0x82, 0xff, 0xe8, 0x8e, 0x8e, 0xff, 0xee, 0x94, 0x94, 0xff, 0xe8, 0x8e, 0x8e, 0xff, 0xdc, 0x82, 0x82, 0xff, 0xca, 0x70, 0x70,
	0xff, 0xb5, 0x5b, 0x5b, 0xff, 0xa5, 0x68, 0x68, 0xf1, 0xae, 0xae, 0xae, 0xb0, 0xd9, 0xd8, 0xd9, 0xbf, 0xe2, 0xe1, 0xe2, 0x1f, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff,
	0x1f, 0x00, 0x00, 0x00, 0xbd, 0xe3, 0xe2, 0xe3, 0xaf, 0xc8, 0xc7, 0xc8, 0xe5, 0xa0, 0xa0, 0xa0, 0xff, 0x9a, 0x7c, 0x7c, 0xff, 0x9d, 0x43, 0x43, 0xff, 0xb8, 0x5e, 0x5e, 0xff, 0xca, 0x70, 0x70, 0xff, 0xdc, 0x82, 0x82, 0xff, 0xee, 0x94, 0x94,
	0xff, 0xfa, 0xa0, 0xa0, 0xff, 0xee, 0x94, 0x94, 0xff, 0xdc, 0x82, 0x82, 0xff, 0xca, 0x70, 0x70, 0xff, 0xab, 0x50, 0x50, 0xff, 0xa1, 0x83, 0x83, 0xe4, 0xaa, 0xaa, 0xaa, 0xb1, 0xd7, 0xd6, 0xd7, 0xbe, 0xe6, 0xe5, 0xe6, 0x1f, 0x00, 0x00, 0x00,
	0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x1e, 0x00, 0x00, 0x00, 0xbc, 0xe7, 0xe6, 0xe7, 0xb1, 0xc4, 0xc3, 0xc4, 0xcb, 0x9a, 0x9a, 0x9a, 0xfe, 0x97, 0x96, 0x96, 0xff, 0x90, 0x4a, 0x4a,
	0xff, 0xa4, 0x49, 0x49, 0xff, 0xca, 0x70, 0x70, 0xff, 0xdc, 0x82, 0x82, 0xff, 0xe8, 0x8e, 0x8e, 0xff, 0xee, 0x94, 0x94, 0xff, 0xe8, 0x8e, 0x8e, 0xff, 0xdc, 0x82, 0x82, 0xff, 0xaf, 0x55, 0x55, 0xff, 0x96, 0x51, 0x51, 0xfe, 0x9e, 0x9d, 0x9d,
	0xca, 0xaa, 0xaa, 0xaa, 0xb3, 0xd2, 0xd1, 0xd2, 0xbd, 0xe9, 0xe8, 0xe9, 0x1f, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x1e, 0x00, 0x00, 0x00, 0xbc, 0xeb, 0xea, 0xeb,
	0xb1, 0xc9, 0xc8, 0xc9, 0xbb, 0x9f, 0x9f, 0x9f, 0xe0, 0x89, 0x89, 0x89, 0xff, 0x94, 0x93, 0x93, 0xff, 0x8c, 0x47, 0x47, 0xff, 0xa5, 0x4b, 0x4b, 0xff, 0xc4, 0x6a, 0x6a, 0xff, 0xd3, 0x79, 0x79, 0xff, 0xd3, 0x79, 0x79, 0xff, 0xce, 0x73, 0x73,
	0xff, 0xaf, 0x54, 0x54, 0xff, 0x8f, 0x49, 0x49, 0xff, 0x98, 0x97, 0x97, 0xe0, 0x95, 0x95, 0x95, 0xba, 0xb3, 0xb3, 0xb3, 0xb3, 0xd7, 0xd6, 0xd7, 0xbd, 0xed, 0xec, 0xed, 0x1e, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff,
	0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x1e, 0x00, 0x00, 0x00, 0xbb, 0xee, 0xed, 0xee, 0xaf, 0xd7, 0xd6, 0xd7, 0xb6, 0xb3, 0xb3, 0xb3, 0xbf, 0x91, 0x91, 0x91, 0xe1, 0x82, 0x82, 0x82, 0xfe, 0x8c, 0x8b, 0x8b, 0xff, 0x8d, 0x6e, 0x6e,
	0xff, 0x8a, 0x4d, 0x4d, 0xff, 0x89, 0x43, 0x43, 0xff, 0x89, 0x43, 0x43, 0xff, 0x8a, 0x4d, 0x4d, 0xff, 0x8f, 0x71, 0x71, 0xfe, 0x92, 0x91, 0x91, 0xe1, 0x90, 0x90, 0x90, 0xbf, 0xab, 0xab, 0xab, 0xb5, 0xca, 0xc9, 0xca, 0xb1, 0xe5, 0xe4, 0xe5,
	0xbc, 0xf1, 0xf0, 0xf1, 0x1e, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x1e, 0x00, 0x00, 0x00, 0xb9, 0xf3, 0xf2, 0xf3, 0xac, 0xe8, 0xe7, 0xe8, 0xae, 0xd4, 0xd3, 0xd4,
	0xb4, 0xb8, 0xb7, 0xb8, 0xbc, 0x9a, 0x9a, 0x9a, 0xd0, 0x85, 0x85, 0x85, 0xea, 0x84, 0x84, 0x84, 0xf5, 0x88, 0x88, 0x88, 0xf8, 0x88, 0x88, 0x88, 0xf8, 0x89, 0x89, 0x89, 0xf5, 0x89, 0x89, 0x89, 0xea, 0x8b, 0x8b, 0x8b, 0xd0, 0x95, 0x95, 0x95,
	0xbc, 0xb2, 0xb2, 0xb2, 0xb4, 0xd4, 0xd3, 0xd4, 0xad, 0xec, 0xeb, 0xec, 0xae, 0xf7, 0xf6, 0xf7, 0xba, 0xf6, 0xf5, 0xf6, 0x1e, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff,
	0x1f, 0x00, 0x00, 0x00, 0xbb, 0xf3, 0xf2, 0xf3, 0xae, 0xea, 0xe9, 0xea, 0xad, 0xe4, 0xe3, 0xe4, 0xae, 0xd9, 0xd8, 0xd9, 0xb2, 0xc5, 0xc4, 0xc5, 0xb7, 0xb0, 0xb0, 0xb0, 0xb8, 0xa5, 0xa5, 0xa5, 0xb9, 0xa3, 0xa3, 0xa3, 0xb9, 0xa8, 0xa8, 0xa8,
	0xb9, 0xac, 0xac, 0xac, 0xb9, 0xb0, 0xb0, 0xb0, 0xb8, 0xb6, 0xb6, 0xb6, 0xb7, 0xc3, 0xc2, 0xc3, 0xb2, 0xd8, 0xd7, 0xd8, 0xae, 0xee, 0xed, 0xee, 0xac, 0xf8, 0xf7, 0xf8, 0xb0, 0xf8, 0xf7, 0xf8, 0xbc, 0xf6, 0xf5, 0xf6, 0x1f, 0x00, 0x00, 0x00,
	0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x16, 0x00, 0x00, 0x00, 0xd0, 0xd1, 0xd0, 0xd1, 0xc8, 0xc3, 0xc3, 0xc3, 0xc7, 0xbf, 0xbf, 0xbf, 0xc7, 0xbb, 0xbb, 0xbb, 0xc7, 0xb8, 0xb8, 0xb8,
	0xc7, 0xb4, 0xb4, 0xb4, 0xc7, 0xb1, 0xb1, 0xb1, 0xc7, 0xae, 0xae, 0xae, 0xc7, 0xac, 0xac, 0xac, 0xc7, 0xb0, 0xb0, 0xb0, 0xc7, 0xb4, 0xb4, 0xb4, 0xc7, 0xb6, 0xb6, 0xb6, 0xc7, 0xba, 0xba, 0xba, 0xc7, 0xbd, 0xbd, 0xbd, 0xc7, 0xc1, 0xc1, 0xc1,
	0xc7, 0xc4, 0xc4, 0xc4, 0xc9, 0xca, 0xc9, 0xca, 0xd0, 0xd3, 0xd2, 0xd3, 0x16, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x0b, 0x00, 0x00, 0x00, 0x16, 0x00, 0x00, 0x00,
	0x22, 0x00, 0x00, 0x00, 0x21, 0x00, 0x00, 0x00, 0x21, 0x00, 0x00, 0x00, 0x21, 0x00, 0x00, 0x00, 0x21, 0x00, 0x00, 0x00, 0x21, 0x00, 0x00, 0x00, 0x21, 0x00, 0x00, 0x00, 0x21, 0x00, 0x00, 0x00, 0x21, 0x00, 0x00, 0x00, 0x21, 0x00, 0x00, 0x00,
	0x21, 0x00, 0x00, 0x00, 0x21, 0x00, 0x00, 0x00, 0x21, 0x00, 0x00, 0x00, 0x21, 0x00, 0x00, 0x00, 0x21, 0x00, 0x00, 0x00, 0x22, 0x00, 0x00, 0x00, 0x16, 0x00, 0x00, 0x00, 0x0b, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff,
};
#else
const uint32_t icon32[] =
{
	0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff,
	0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x0b000000, 0xc7fffeff, 0xc8fbfafb, 0xc8f8f7f8, 0xc8f4f3f4, 0xc8f1f0f1, 0xc8eeedee, 0xc8ebeaeb, 0xc8e7e6e7, 0xc8e5e4e5, 0xc8e6e5e6, 0xc8eae9ea, 0xc8edeced, 0xc8f1f0f1, 0xc8f4f3f4, 0xc8f7f6f7,
	0xc8f9f8f9, 0xc8fdfcfd, 0xc7ffffff, 0x0b000000, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x16000000, 0xc6fefdfe, 0xb2fdfcfd, 0xaff8f7f8, 0xb0f1f0f1, 0xb0edeced, 0xb0e7e6e7, 0xb0e2e1e2, 0xb0dddcdd, 0xb0d7d6d7, 0xb0d2d1d2, 0xb0d5d4d5, 0xb0dbdadb,
	0xb0e1e0e1, 0xb0e6e5e6, 0xb0ebeaeb, 0xb0f1f0f1, 0xb4f7f6f7, 0xc7fdfcfd, 0x16000000, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x20000000, 0xc5fcfbfc, 0xacfdfcfd, 0xaafcfbfc, 0xaaf6f5f6, 0xaaefeeef, 0xbfe9e8e9, 0xe1ecebec, 0xf1f3f2f3, 0xf5f8f7f8,
	0xf5fcfbfc, 0xf1f6f5f6, 0xe1ecebec, 0xbfdfdedf, 0xaadddcdd, 0xaae3e2e3, 0xa9e9e8e9, 0xaff1f0f1, 0xc6f9f8f9, 0x20000000, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x20000000, 0xc4f7f6f7, 0xadf8f7f8, 0xabfdfcfd, 0xabfcfbfc, 0xd3eae9ea, 0xfde7e6e6,
	0xffe3c4c4, 0xffe1a5a5, 0xffe8a2a2, 0xffe8a3a3, 0xffeaadad, 0xffeacccc, 0xfdecebeb, 0xd3e0dfe0, 0xabdddcdd, 0xaae3e2e3, 0xb0ecebec, 0xc5f6f5f6, 0x20000000, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x20000000, 0xc4f3f2f3, 0xadf2f1f2, 0xabf8f7f8,
	0xd3e5e4e5, 0xffdcdbdb, 0xffce8989, 0xffac5252, 0xff963b3b, 0xff903636, 0xff913636, 0xff983d3d, 0xffb75c5c, 0xffd99494, 0xffe4e3e3, 0xd3dbdadb, 0xaadddcdd, 0xb0e6e5e6, 0xc5f3f2f3, 0x20000000, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x20000000,
	0xc3efeeef, 0xadecebec, 0xbfe3e2e3, 0xfdcfcece, 0xffc17c7c, 0xffa84e4e, 0xff892f2f, 0xff953b3b, 0xff953b3b, 0xff953b3b, 0xff953b3b, 0xff953b3b, 0xffb25757, 0xffcd8888, 0xfdd5d4d4, 0xbfd4d3d4, 0xb0e0dfe0, 0xc4efeeef, 0x20000000, 0x00ff00ff, 0x00ff00ff,
	0x00ff00ff, 0x00ff00ff, 0x20000000, 0xc2ebeaeb, 0xade6e5e6, 0xe1cacaca, 0xffbea0a0, 0xffa14747, 0xff8f3535, 0xff9b4141, 0xffa14747, 0xffa64c4c, 0xffa64c4c, 0xffa64c4c, 0xffa14747, 0xff9b4141, 0xffad5353, 0xffc8aaaa, 0xe1cacaca, 0xafdad9da, 0xc3ebeaeb,
	0x20000000, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x1f000000, 0xc1e8e7e8, 0xade0dfe0, 0xf1bebebe, 0xffb17575, 0xff973d3d, 0xffa14747, 0xffa64c4c, 0xffb25858, 0xffb85e5e, 0xffb85e5e, 0xffb85e5e, 0xffb25858, 0xffa64c4c, 0xffa84e4e, 0xffbd8181,
	0xf1c2c2c2, 0xafd4d3d4, 0xc2e5e4e5, 0x20000000, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x1f000000, 0xc0e4e3e4, 0xaddcdbdc, 0xf5b6b6b6, 0xffab6666, 0xff9e4343, 0xffa64c4c, 0xffb85e5e, 0xffc46a6a, 0xffca7070, 0xffca7070, 0xffca7070, 0xffc46a6a,
	0xffb85e5e, 0xffa94e4e, 0xffb46f6f, 0xf5bcbcbc, 0xafd2d1d2, 0xc1e2e1e2, 0x1f000000, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x1f000000, 0xbfdeddde, 0xadd7d6d7, 0xf5afafaf, 0xffa45f5f, 0xffa24848, 0xffb25858, 0xffc46a6a, 0xffd07676, 0xffdc8282,
	0xffdc8282, 0xffdc8282, 0xffd07676, 0xffc46a6a, 0xffb25858, 0xffad6868, 0xf5b5b5b5, 0xafd5d4d5, 0xc0deddde, 0x1f000000, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x1f000000, 0xbedfdedf, 0xadcdcccd, 0xf1a7a7a7, 0xff9c5f5f, 0xffa54a4a, 0xffb85e5e,
	0xffca7070, 0xffdc8282, 0xffe88e8e, 0xffee9494, 0xffe88e8e, 0xffdc8282, 0xffca7070, 0xffb55b5b, 0xffa56868, 0xf1aeaeae, 0xb0d9d8d9, 0xbfe2e1e2, 0x1f000000, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x1f000000, 0xbde3e2e3, 0xafc8c7c8, 0xe5a0a0a0,
	0xff9a7c7c, 0xff9d4343, 0xffb85e5e, 0xffca7070, 0xffdc8282, 0xffee9494, 0xfffaa0a0, 0xffee9494, 0xffdc8282, 0xffca7070, 0xffab5050, 0xffa18383, 0xe4aaaaaa, 0xb1d7d6d7, 0xbee6e5e6, 0x1f000000, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x1e000000,
	0xbce7e6e7, 0xb1c4c3c4, 0xcb9a9a9a, 0xfe979696, 0xff904a4a, 0xffa44949, 0xffca7070, 0xffdc8282, 0xffe88e8e, 0xffee9494, 0xffe88e8e, 0xffdc8282, 0xffaf5555, 0xff965151, 0xfe9e9d9d, 0xcaaaaaaa, 0xb3d2d1d2, 0xbde9e8e9, 0x1f000000, 0x00ff00ff, 0x00ff00ff,
	0x00ff00ff, 0x00ff00ff, 0x1e000000, 0xbcebeaeb, 0xb1c9c8c9, 0xbb9f9f9f, 0xe0898989, 0xff949393, 0xff8c4747, 0xffa54b4b, 0xffc46a6a, 0xffd37979, 0xffd37979, 0xffce7373, 0xffaf5454, 0xff8f4949, 0xff989797, 0xe0959595, 0xbab3b3b3, 0xb3d7d6d7, 0xbdedeced,
	0x1e000000, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x1e000000, 0xbbeeedee, 0xafd7d6d7, 0xb6b3b3b3, 0xbf919191, 0xe1828282, 0xfe8c8b8b, 0xff8d6e6e, 0xff8a4d4d, 0xff894343, 0xff894343, 0xff8a4d4d, 0xff8f7171, 0xfe929191, 0xe1909090, 0xbfababab,
	0xb5cac9ca, 0xb1e5e4e5, 0xbcf1f0f1, 0x1e000000, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x1e000000, 0xb9f3f2f3, 0xace8e7e8, 0xaed4d3d4, 0xb4b8b7b8, 0xbc9a9a9a, 0xd0858585, 0xea848484, 0xf5888888, 0xf8888888, 0xf8898989, 0xf5898989, 0xea8b8b8b,
	0xd0959595, 0xbcb2b2b2, 0xb4d4d3d4, 0xadecebec, 0xaef7f6f7, 0xbaf6f5f6, 0x1e000000, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x1f000000, 0xbbf3f2f3, 0xaeeae9ea, 0xade4e3e4, 0xaed9d8d9, 0xb2c5c4c5, 0xb7b0b0b0, 0xb8a5a5a5, 0xb9a3a3a3, 0xb9a8a8a8,
	0xb9acacac, 0xb9b0b0b0, 0xb8b6b6b6, 0xb7c3c2c3, 0xb2d8d7d8, 0xaeeeedee, 0xacf8f7f8, 0xb0f8f7f8, 0xbcf6f5f6, 0x1f000000, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x16000000, 0xd0d1d0d1, 0xc8c3c3c3, 0xc7bfbfbf, 0xc7bbbbbb, 0xc7b8b8b8, 0xc7b4b4b4,
	0xc7b1b1b1, 0xc7aeaeae, 0xc7acacac, 0xc7b0b0b0, 0xc7b4b4b4, 0xc7b6b6b6, 0xc7bababa, 0xc7bdbdbd, 0xc7c1c1c1, 0xc7c4c4c4, 0xc9cac9ca, 0xd0d3d2d3, 0x16000000, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x00ff00ff, 0x0b000000, 0x16000000, 0x22000000, 0x21000000,
	0x21000000, 0x21000000, 0x21000000, 0x21000000, 0x21000000, 0x21000000, 0x21000000, 0x21000000, 0x21000000, 0x21000000, 0x21000000, 0x21000000, 0x21000000, 0x22000000, 0x16000000, 0x0b000000, 0x00ff00ff, 0x00ff00ff,
};
#endif
#else // !__MORPHOS__
const uint8_t icon32[] =
{
#if defined(__PPC__)
	0x00, 0x00, 0x00, 0x18,
	0x00, 0x00, 0x00, 0x14,
	'B', 'Z', '2', '\0',
	0x00, 0x00, 0x01, 0xf1,
#else
	0x18, 0x00, 0x00, 0x00,
	0x14, 0x00, 0x00, 0x00,
	'B', 'Z', '2', '\0',
	0xf1, 0x01, 0x00, 0x00,
#endif

	0x42, 0x5a, 0x68, 0x39, 0x31, 0x41, 0x59, 0x26, 0x53, 0x59, 0x6e, 0xa2, 0x8f, 0x4b, 0x00, 0x00, 0x60, 0x7f, 0xff, 0xc0, 0x08, 0x01, 0x01, 0xf0, 0x00, 0x83, 0x0a, 0x28, 0xff, 0x7e, 0xcd, 0x81, 0x51, 0xeb, 0x24, 0x3e, 0x7f, 0xff, 0xdf, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xd0, 0x03, 0x3e, 0x35, 0xa4, 0xb0, 0x8e, 0xa7, 0x50, 0xd4, 0x54, 0x6c, 0x50, 0xf4, 0x8c, 0x9a, 0x1a, 0x01, 0xa0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x40, 0x01, 0xa0, 0x68, 0x06, 0x80, 0x34, 0x06,
	0x80, 0x68, 0x00, 0x68, 0xd1, 0xa3, 0x26, 0x9a, 0x68, 0xc8, 0xd1, 0xa1, 0x14, 0xd0, 0x26, 0x93, 0x11, 0xa1, 0x90, 0x34, 0xc9, 0xe9, 0x0f, 0x50, 0x62, 0x69, 0x93, 0x43, 0x26, 0x98, 0x10, 0x68, 0xc8, 0x00, 0x00, 0x00, 0x69, 0xa0, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x34, 0x04, 0x2a, 0x13, 0xc1, 0x4f, 0xd5, 0x34, 0xd3, 0x4f, 0x53, 0xca, 0x62, 0x68, 0x00, 0x1a, 0x00, 0xd0, 0xd0, 0x00, 0x00, 0x06, 0x80, 0x0c, 0x40, 0x68, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0c, 0x83, 0x20, 0x02, 0x06, 0x46, 0x8d,
	0x06, 0x81, 0x90, 0xd3, 0x4c, 0x9a, 0x06, 0x4c, 0x26, 0x83, 0x13, 0x11, 0x93, 0x46, 0x81, 0x90, 0xc4, 0x60, 0x26, 0x8c, 0x40, 0x03, 0x46, 0x08, 0x68, 0x61, 0x18, 0x99, 0x32, 0x69, 0x91, 0x91, 0x89, 0xa6, 0x83, 0x23, 0x02, 0x60, 0x94, 0x84, 0x65, 0x02,
	0x68, 0xc8, 0xd0, 0x9a, 0x1a, 0x64, 0xd1, 0x93, 0x46, 0x80, 0x00, 0x1a, 0x34, 0x34, 0xd0, 0xf5, 0x36, 0x93, 0xd3, 0x53, 0x04, 0x60, 0x26, 0x80, 0x1a, 0x1a, 0x01, 0xa0, 0xd3, 0x40, 0x69, 0xa0, 0x00, 0x0d, 0x1e, 0xa3, 0x4d, 0x06, 0x22, 0x96, 0xa7, 0x9e,
	0x14, 0x29, 0x48, 0xf8, 0x8f, 0x3e, 0x88, 0x0a, 0x73, 0x54, 0xe1, 0x11, 0x8e, 0x1c, 0xa1, 0x48, 0x39, 0x06, 0x35, 0x4e, 0x00, 0x44, 0xbb, 0x56, 0x6a, 0x22, 0x20, 0xa5, 0x29, 0x00, 0x52, 0x08, 0x00, 0xa5, 0x26, 0x26, 0x63, 0x06, 0x13, 0x72, 0x32, 0x98,
	0x0a, 0xf8, 0xfd, 0x3d, 0xfe, 0xc5, 0x3e, 0x27, 0xcb, 0x22, 0x6e, 0x4c, 0x1f, 0xeb, 0x50, 0x9c, 0x00, 0xaf, 0xce, 0x49, 0xce, 0xf0, 0x6c, 0x69, 0x4b, 0x3b, 0x34, 0x29, 0xc4, 0x99, 0xc3, 0xd1, 0x16, 0xa5, 0x49, 0x14, 0xb8, 0xb8, 0xab, 0x0b, 0x92, 0x62,
	0x8a, 0xc4, 0x2e, 0x96, 0xa5, 0xb6, 0x5c, 0x10, 0xd6, 0xf2, 0xc0, 0x26, 0x17, 0x00, 0x34, 0xc0, 0x0d, 0x5a, 0x0c, 0x42, 0xea, 0xec, 0x4c, 0xc6, 0x7a, 0xd0, 0xd6, 0xb7, 0xad, 0xdf, 0x39, 0xbf, 0x9d, 0x14, 0xf6, 0x13, 0xa1, 0x00, 0x50, 0x00, 0x62, 0x3b,
	0xc6, 0xa2, 0xc2, 0x44, 0xb1, 0x44, 0xa6, 0xe5, 0x59, 0x14, 0x3c, 0x2a, 0x69, 0xf9, 0x67, 0x75, 0x09, 0x88, 0x60, 0x5a, 0x61, 0x5b, 0x78, 0x40, 0xb8, 0x03, 0x4f, 0xc4, 0xc6, 0xb9, 0xea, 0x5d, 0xe3, 0x97, 0xa5, 0xb9, 0x7c, 0x60, 0xe2, 0x29, 0x0b, 0x32,
	0x98, 0xe6, 0x30, 0x20, 0x05, 0x04, 0x15, 0x39, 0xcd, 0x15, 0x04, 0x5a, 0x01, 0xbf, 0xe6, 0x98, 0xee, 0x29, 0x30, 0x88, 0x81, 0x03, 0x34, 0xe4, 0x83, 0x28, 0x06, 0x03, 0xf5, 0xad, 0x8a, 0x1d, 0x5c, 0x97, 0x24, 0x3a, 0xc0, 0xb4, 0x24, 0x4a, 0x17, 0xe4,
	0xbc, 0xec, 0x28, 0x81, 0x87, 0x86, 0xdc, 0xac, 0x85, 0x23, 0xc8, 0x31, 0x08, 0xf4, 0x7c, 0x60, 0x61, 0x7f, 0x62, 0xb8, 0x57, 0xef, 0x31, 0x31, 0xbd, 0xba, 0x40, 0x60, 0x5f, 0x5f, 0x2e, 0x07, 0x97, 0xbc, 0x74, 0xb1, 0x71, 0xf2, 0xd6, 0x8e, 0x13, 0x3f,
	0xc7, 0xc7, 0xf1, 0x31, 0x43, 0xc8, 0x58, 0xd8, 0x53, 0xa8, 0x60, 0x9d, 0xbf, 0x18, 0xb2, 0x05, 0xe8, 0xbc, 0x9f, 0xd5, 0x5f, 0x48, 0xf2, 0x28, 0xfa, 0xf9, 0x74, 0xfa, 0x0b, 0x1c, 0xf3, 0x1e, 0x25, 0x6f, 0x04, 0x83, 0x83, 0x27, 0xcd, 0x48, 0xc7, 0x34,
	0x0e, 0x29, 0x74, 0x26, 0x8a, 0x04, 0x9c, 0xa9, 0x61, 0x90, 0x2d, 0xf8, 0xe5, 0x3f, 0xf9, 0x44, 0x3a, 0x35, 0xe0, 0x3c, 0x1e, 0x73, 0x77, 0x08, 0xc5, 0x66, 0x94, 0x54, 0xeb, 0x25, 0x50, 0x11, 0xbd, 0x89, 0x9d, 0x95, 0x26, 0x7c, 0xf4, 0x04, 0xfb, 0x6d,
	0x1e, 0xfe, 0xdd, 0x72, 0x69, 0x37, 0x13, 0x27, 0x2f, 0x5f, 0x01, 0x0f, 0x23, 0x18, 0x58, 0x54, 0x99, 0x07, 0x94, 0xc9, 0x8a, 0x46, 0xa1, 0x4b, 0xd7, 0x24, 0xfe, 0x37, 0x5f, 0x04, 0x9b, 0x35, 0x64, 0x28, 0x31, 0x4c, 0x12, 0x8d, 0x44, 0x38, 0xef, 0xe8,
	0xca, 0xad, 0x8d, 0x35, 0x6c, 0x27, 0xa7, 0x04, 0x77, 0xe5, 0xf6, 0x31, 0x12, 0xa0, 0x88, 0xe2, 0x8e, 0x13, 0x77, 0x0d, 0xd9, 0xf6, 0x53, 0x99, 0x0e, 0x0c, 0x7d, 0xc8, 0x78, 0x05, 0x82, 0x05, 0x06, 0x0a, 0x14, 0x90, 0x77, 0x1f, 0x0a, 0x7d, 0xe8, 0x15,
	0x2b, 0x10, 0x52, 0x67, 0x85, 0x12, 0x39, 0xb5, 0xe7, 0xe7, 0xc1, 0x49, 0xe9, 0xa9, 0x01, 0x37, 0x60, 0x4a, 0x23, 0x1f, 0x04, 0x11, 0x33, 0x60, 0x8d, 0x52, 0x12, 0x49, 0x53, 0x42, 0x56, 0x50, 0x9f, 0x96, 0x84, 0x60, 0x5c, 0x88, 0xb9, 0x65, 0x43, 0x98,
	0xec, 0xc0, 0x20, 0x16, 0xcb, 0xa5, 0x26, 0x0c, 0x4c, 0xd0, 0xc9, 0x2c, 0x3a, 0x50, 0x79, 0x15, 0xaa, 0x15, 0xc1, 0xc7, 0xa7, 0x89, 0x57, 0x04, 0xd6, 0x2b, 0xed, 0xb2, 0xd4, 0xec, 0x96, 0x32, 0x4c, 0xe1, 0xd4, 0x5f, 0xeb, 0x45, 0xe4, 0x11, 0xfd, 0x08,
	0x8f, 0xc9, 0x21, 0xad, 0x8e, 0x11, 0x40, 0x01, 0x56, 0x3a, 0x46, 0xa2, 0x1d, 0xc8, 0x08, 0x71, 0x16, 0x8d, 0xeb, 0xf3, 0xf4, 0x63, 0x8e, 0x1f, 0x97, 0xaa, 0x08, 0x0b, 0x1b, 0xc3, 0x54, 0xa2, 0xb7, 0x06, 0x43, 0x12, 0x32, 0xc6, 0xa7, 0x63, 0x94, 0x80,
	0x0f, 0x33, 0x00, 0x62, 0x74, 0x6d, 0x61, 0x83, 0x14, 0x25, 0xf2, 0xba, 0xe8, 0x9b, 0x64, 0x69, 0x22, 0x79, 0xea, 0xe4, 0x33, 0x01, 0x8c, 0x91, 0x51, 0x9e, 0x96, 0xd7, 0x6d, 0x2b, 0x8a, 0x17, 0xc8, 0xb0, 0xeb, 0x5f, 0x89, 0x28, 0x61, 0x3e, 0xff, 0x44,
	0x7a, 0x08, 0x84, 0xe5, 0x90, 0x31, 0xe0, 0x95, 0x29, 0xcb, 0xb5, 0x1a, 0x65, 0xd1, 0xdb, 0x8f, 0x0b, 0x93, 0xbd, 0x4b, 0xcb, 0xf6, 0x93, 0xd0, 0xe7, 0x75, 0x6f, 0x72, 0x48, 0xf0, 0x67, 0x76, 0xf0, 0x2d, 0x52, 0xea, 0xe2, 0x12, 0x4f, 0x6f, 0x1b, 0x56,
	0x0e, 0x48, 0x6b, 0x85, 0x5e, 0xa7, 0x71, 0x51, 0xbd, 0x06, 0x8e, 0xa2, 0x8f, 0x5e, 0x0e, 0xad, 0x51, 0x2e, 0xa9, 0x94, 0x54, 0x08, 0x3e, 0xd4, 0x29, 0x23, 0x0d, 0x83, 0x60, 0x0e, 0x0d, 0x2b, 0xf6, 0x85, 0xb4, 0x05, 0x00, 0x26, 0x02, 0x2c, 0x55, 0x89,
	0x42, 0xab, 0xa1, 0x54, 0xe8, 0xe3, 0xe3, 0x10, 0xd0, 0x49, 0x16, 0x9d, 0x16, 0x02, 0x05, 0x1a, 0x20, 0x96, 0xb1, 0x61, 0xe7, 0x9b, 0x60, 0x02, 0x58, 0x02, 0x0f, 0x70, 0x2a, 0x72, 0xe5, 0x23, 0xed, 0x4a, 0x07, 0xe0, 0x59, 0x24, 0x60, 0x72, 0x46, 0x98,
	0xfd, 0xb2, 0x35, 0x37, 0xf1, 0xaa, 0x65, 0x89, 0x9b, 0x27, 0x15, 0x65, 0x67, 0x55, 0x69, 0x45, 0x18, 0xd9, 0x45, 0x30, 0x24, 0x6e, 0xe2, 0x2b, 0x6a, 0x20, 0x50, 0x03, 0x26, 0xa7, 0xa2, 0x65, 0xa0, 0x16, 0x60, 0x10, 0x32, 0xe1, 0x28, 0x10, 0x9b, 0xd6,
	0x95, 0x10, 0x36, 0x9e, 0xe8, 0x41, 0xa2, 0xa3, 0xdf, 0x54, 0xb2, 0x00, 0x38, 0x01, 0xea, 0x0a, 0xa8, 0xf7, 0x61, 0x1c, 0xc0, 0x30, 0x45, 0x5a, 0xd5, 0xef, 0xc6, 0x51, 0x3c, 0xb3, 0x07, 0x50, 0xfe, 0x29, 0x75, 0xbe, 0x22, 0x68, 0x30, 0x04, 0xc0, 0x08,
	0x22, 0x42, 0x47, 0x88, 0x16, 0x21, 0x3c, 0x7a, 0xf6, 0x77, 0x27, 0x9c, 0xc5, 0xdf, 0x07, 0x3f, 0x79, 0x42, 0xe4, 0x49, 0x52, 0xde, 0x90, 0x10, 0x10, 0x80, 0xa5, 0x21, 0x00, 0xf1, 0x5e, 0xcd, 0x69, 0x76, 0xd4, 0xb3, 0xf1, 0x35, 0xae, 0xef, 0xcc, 0xe3,
	0x64, 0x00, 0x7a, 0x30, 0xe8, 0x35, 0xa6, 0xfb, 0x67, 0x9d, 0xfe, 0x85, 0xc6, 0x37, 0x71, 0xef, 0xe7, 0xda, 0xe1, 0x82, 0x52, 0x36, 0x34, 0x12, 0xb7, 0x48, 0xb5, 0x3b, 0xa3, 0x6e, 0xfd, 0xb5, 0x8a, 0x0e, 0xee, 0x5d, 0x7e, 0xb4, 0xef, 0x12, 0x39, 0x86,
	0x4e, 0x89, 0x45, 0x81, 0x0c, 0x41, 0x49, 0xbb, 0x3b, 0x5e, 0x04, 0x38, 0xe7, 0x2d, 0x66, 0x92, 0x03, 0x43, 0xd4, 0x43, 0xb0, 0x6b, 0xed, 0xbc, 0x71, 0xae, 0xa5, 0x6a, 0xc9, 0x89, 0x4c, 0x08, 0x8f, 0x22, 0xb4, 0xea, 0xce, 0x21, 0xa3, 0xcd, 0x83, 0x0b,
	0x89, 0x24, 0x20, 0xd3, 0xab, 0x28, 0xcb, 0xfe, 0x2e, 0xe4, 0x8a, 0x70, 0xa1, 0x20, 0xdd, 0x45, 0x1e, 0x96,
};
#endif // !__MORPHOS__
