/* SetManager 2.0 */

OPT PREPROCESS
OPT OSVERSION=37


/*
TODO:

- Test it under OS 2.04

- Improve keyboard control.

- Memory header not found at exit when started from WB sometime (!?)

- Highlight function name
>  Juste un click highlight toutes les patches sur le vecteur genre en bleu,
>  avec la "current" en blanc, un double toggle la current...

*/


/* CA stuff */

MODULE 'tools/boopsi','amigalib/lists'
MODULE 'classes/window','gadgets/listbrowser','listbrowser','dos/dos',
       'other/classact_macros','layout','gadgets/layout',
       'window','getfile','gadgets/getfile',
       'exec/memory','dos/dosextens', 'exec/ports','exec/libraries',
       'exec/lists','exec/nodes','exec/tasks','exec/semaphores',
       'amigalib/ports','amigalib/mempools','exec/memory'

MODULE 'amigalib/argarray',
       'tools/classact_lib',
       'utility/tagitem',
       'intuition/intuition',
       'devices/inputevent'

MODULE 'intuition/gadgetclass','intuition/icclass','libraries/gadtools',
       'graphics/gfxbase','graphics/text',
       'intuition','graphics','dos','intuition/classes','intuition/classusr',
       'utility','gadtools','intuition/screens'

MODULE 'amigalib/cx','libraries/commodities',
       'commodities'

OBJECT setmanport
   mp:mp
   version[4]:ARRAY
   sem:ss
   lh:mlh
ENDOBJECT


OBJECT setnode
   n:mln
   lib:PTR TO lib
   offset
   task:PTR TO tc
   taskname[22]:ARRAY
   jmp1:INT
   setfunc
   jmp2:INT
   prevfunc
   nextfunc
ENDOBJECT


OBJECT libraryinfo
   next:PTR TO libraryinfo
   libraryname[30]:ARRAY
   entries:INT
   functionname:PTR TO CHAR  /*First ptr */
ENDOBJECT



RAISE "CXER" IF CxBroker()=NIL,
      "CXER" IF CreateCxObj()=NIL,  -> the CxXXX macros use this
      "MEM" IF CreateMsgPort()=NIL


#define VERSION '2.0'	/* must be 3 characters - for version CHECKS. */

#define SFOFFSET		(-$01A4)	/* SetFunction() vector */

CONST RAWKEY_CURSORUP = 76
CONST RAWKEY_CURSORDOWN = 77
CONST RAWKEY_CURSORRIGHT = 78
CONST RAWKEY_CURSORLEFT = 79

CONST JMPCODE =	$4ef9
CONST BRACODE =	$6004



DEF smport:PTR TO setmanport
DEF lbobj, win, winobj, libinfolist:PTR TO libraryinfo
DEF patchlist:PTR TO lh
DEF pool=NIL, title[80]:STRING


PROC main() HANDLE
DEF visual=NIL, menustrip=NIL
DEF managerport:PTR TO mp
DEF itemnum
DEF ci:PTR TO columninfo

DEF signal, result, tmpres, tmpres2, done=FALSE
DEF portsig, winsig,code, count,tmpstr[80]:STRING,
    ievent:inputevent

DEF font:PTR TO textattr, scr=NIL:PTR TO screen, tmpfont:PTR TO textfont, gfxb:PTR TO gfxbase
DEF broker_mp=NIL:PTR TO mp, broker=NIL, filter = NIL, cxsigflag, msg
DEF argarray:PTR TO LONG, rdargs=NIL

DEF ttypes=NIL, lb:PTR TO lib

   Forbid()
   IF (smport := FindPort('SetMan')) = NIL
      Permit()
      easy_r('SetMan is not running.','Damn!')
      RETURN 20
   ENDIF

   Permit()


   IF StrCmp(smport.version,VERSION)=NIL
      easy_r('Incompatible with the running SetMan version!','Damn!')
      RETURN 20
   ENDIF

   Forbid()

   IF FindPort('SetFuncManager')
      Permit()
      easy_r('SetManager already running.','Ok')
      RETURN 10
   ENDIF

   IF (managerport := createPort('SetFuncManager',NIL)) = NIL
      Permit()
      RETURN 20
   ENDIF

   Permit()

   IF (pool := libCreatePool(MEMF_ANY OR MEMF_CLEAR,10000,500))=NIL THEN Raise("MEM")

   utilitybase := myOpenClass('utility.library',37,TRUE)
   windowbase :=myOpenClass('window.class',42,FALSE)
   layoutbase :=myOpenClass('gadgets/layout.gadget',41,FALSE)
   listbrowserbase :=myOpenClass('gadgets/listbrowser.gadget',41,FALSE)
   lb := listbrowserbase
   gadtoolsbase := myOpenClass('gadtools.library',37,TRUE)
   cxbase := myOpenClass('commodities.library',37,TRUE)
   iconbase := myOpenClass('icon.library',37,TRUE)

/* Parse arguments */
   argarray:=[0,'control lalt s','YES','FD:']

   IF wbmessage
      IF (ttypes:=argArrayInit())=NIL THEN Raise("ARGS")
      tmpres := argInt(ttypes, 'CX_PRIORITY', 0)
      argarray[1] := argString(ttypes, 'CX_POPKEY', 'control lalt s')
      argarray[2] := argString(ttypes, 'CX_POPUP', 'YES')
      argarray[3] := argString(ttypes, 'FDPATH', 'FD:')
   ELSE

      IF (rdargs := ReadArgs('PRI=CX_PRIORITY/N/K,KEY=CX_POPKEY/K,CX_POPUP/K,FDPATH/K',argarray,NIL)) = NIL
         PrintFault(IoErr(),NIL)
         Raise("ARGS")
      ENDIF
      tmpres := (IF argarray[0] THEN Long(argarray[0]) ELSE 0)
   ENDIF


/* Setup Commodity */

   broker_mp:=CreateMsgPort()
   cxsigflag:=Shl(1, broker_mp.sigbit)

   broker:=CxBroker([NB_VERSION, 0,  -> E-Note: pad byte!
                    'SetManager',
                    {version_string},
                    'System patches manager',
                    NBU_UNIQUE,
                    COF_SHOW_HIDE, tmpres,
                    0, broker_mp, 0]:newbroker, NIL)

  -> hotKey() is an amigalib function that creates a filter, sender and
  -> translate CxObject and connects them to report a hot key press and
  -> delete its input event.
   IF NIL=(filter:=hotKey(argarray[1], broker_mp, 1)) THEN Raise("CXER")
   AttachCxObj(broker, filter)
   IF CxObjError(filter)<>FALSE THEN Raise("CXER")


   libinfolist := readAllFD(argarray[3])

   patchlist,count := buildlist()

   ci := [0, 'Handler Task', (CIF_DRAGGABLE OR CIF_SORTABLE),
          0, 'Code',(CIF_DRAGGABLE OR CIF_SORTABLE),
          0, 'Function', (CIF_DRAGGABLE OR CIF_SORTABLE),
          0, 'State', (CIF_DRAGGABLE OR CIF_SORTABLE),
          -1,-1,-1]:columninfo

   gfxb := gfxbase

   tmpfont := gfxb.defaultfont
   font := [tmpfont.mn.ln.name,tmpfont.ysize,tmpfont.style,tmpfont.flags]:textattr

   IF (scr := LockPubScreen(NIL))=NIL THEN Raise("GUI")
   IF (visual:=GetVisualInfoA(scr,NIL))=NIL THEN Raise("GUI")

   IF (menustrip:=CreateMenusA([Title('Project'),
                                 Item('About...','A',NIL),
                                 ItemBar,
                                 Item('Refresh','R',NIL),
                                 ItemBar,
                                 Item('Save...','S',NIL),
                                 ItemBar,
                                 Item('Hide','H',NIL),
                                 ItemBar,
                                 Item('Quit','Q',NIL),
                              EndMenu]:newmenu,NIL))=NIL THEN Raise("GUI")

   IF LayoutMenusA(menustrip,visual,[GTMN_NEWLOOKMENUS,TRUE,NIL])=FALSE THEN Raise("GUI")

   winobj := WindowObject,
                   WA_IDCMP, (IDCMP_RAWKEY OR IDCMP_MENUPICK),
                   WA_AUTOADJUST,TRUE,
                   WA_SIZEGADGET, TRUE,
                   WA_DEPTHGADGET, TRUE,
                   WA_DRAGBAR, TRUE,
                   WA_SIZEBBOTTOM,TRUE,
                   WA_CLOSEGADGET, TRUE,
                   WA_ACTIVATE, TRUE,
                   WA_WIDTH,610,
                   WA_HEIGHT,scr.height*3/4,
                   WA_TITLE, StringF(title,'\s  -  \d patch\sfound.',{version_string},count,(IF count>1 THEN 'es ' ELSE ' ')),
                   WINDOW_POSITION, WPOS_CENTERSCREEN,
                   WINDOW_MENUSTRIP, menustrip,

                   WINDOW_PARENTGROUP, HGroupObject,
                      LAYOUT_SPACEOUTER, TRUE,
                      LAYOUT_DEFERLAYOUT, TRUE,
                      
                      StartMember, lbobj := ListBrowserObject,
                         GA_TEXTATTR, font,
                         GA_ID, 1,
                         LISTBROWSER_TITLECLICKABLE, TRUE,
                         LISTBROWSER_COLUMNTITLES, (IF count THEN TRUE ELSE FALSE),
                         LISTBROWSER_AUTOFIT, TRUE,
                         LISTBROWSER_SHOWSELECTED, TRUE,
                         GA_RELVERIFY, TRUE,
                         LISTBROWSER_LABELS, patchlist,
                         LISTBROWSER_COLUMNINFO, ci,
                         LISTBROWSER_FASTRENDER,TRUE,
                      EndMember,
                   EndGroup,
                EndWindow

   IF (winobj)

      ActivateCxObj(broker, TRUE)
      
      IF Stricmp(argarray[2],'YES')=0
         win := CA_OpenWindow(winobj)
         GetAttr( WINDOW_SIGMASK, winobj, {winsig})
      ENDIF


      WHILE (done = FALSE)
         portsig := Shl(1,managerport.sigbit)
         signal := Wait(cxsigflag OR winsig OR portsig OR SIGBREAKF_CTRL_C)

         IF (signal AND winsig)

            WHILE ((result := CA_HandleInput(winobj,{code})) <> WMHI_LASTMSG)

               tmpres := (result AND WMHI_CLASSMASK)
               SELECT tmpres
         
                   CASE WMHI_CLOSEWINDOW
                        done := TRUE

                   CASE WMHI_GADGETUP
                      IF (result AND WMHI_GADGETMASK) = 1 THEN clickNode()

                    CASE WMHI_RAWKEY
                         GetAttr( WINDOW_INPUTEVENT, winobj, {ievent} )
                         code := Shr(code,16)

                         IF (Not(code AND IECODE_UP_PREFIX)) AND (Not(IsListEmpty(patchlist)))

                            tmpres := -1  -> Init it

                            SELECT code
                               CASE $40
                                  clickNode()

                               CASE RAWKEY_CURSORUP

                                    IF (ievent.qualifier AND IEQUALIFIER_CONTROL)

                                       setPage(LBP_TOP)
                                       
                                       tmpres := 0

                                    ELSEIF (ievent.qualifier AND (IEQUALIFIER_RSHIFT OR IEQUALIFIER_LSHIFT))

                                       setPage(LBP_PAGEUP)

                                       IF (lb.version >41) OR (lb.revision >= 407)
                                          GetAttr(LISTBROWSER_TOP, lbobj, {tmpres})
                                       ENDIF
                                    ELSE
                                       getAttrsA(lbobj, [LISTBROWSER_SELECTED, {tmpres},TAG_END])
                                       tmpres := (IF tmpres<=0 THEN 0 ELSE (tmpres-1))
                                       SetGadgetAttrsA(lbobj, win, NIL, [LISTBROWSER_MAKEVISIBLE, tmpres, TAG_END] )
                                    ENDIF
                                    
                               CASE RAWKEY_CURSORDOWN
                                    IF (ievent.qualifier AND IEQUALIFIER_CONTROL)
                                       setPage(LBP_BOTTOM)
                                       GetAttr(LISTBROWSER_TOTALNODES, lbobj, {tmpres})
                                       tmpres := tmpres-1

                                    ELSEIF (ievent.qualifier AND (IEQUALIFIER_RSHIFT OR IEQUALIFIER_LSHIFT))
                                       setPage(LBP_PAGEDOWN)

                                       IF (lb.version >41) OR (lb.revision >= 407)
                                          GetAttr(LISTBROWSER_TOP, lbobj, {tmpres})
                                       ENDIF

                                    ELSE
                                       getAttrsA(lbobj, [LISTBROWSER_TOTALNODES, {tmpres2},
                                                         LISTBROWSER_SELECTED, {tmpres},
                                                         TAG_END])
                                       tmpres := (IF tmpres+1 < tmpres2 THEN (tmpres+1) ELSE tmpres2-1)
                                       SetGadgetAttrsA(lbobj, win, NIL, [LISTBROWSER_MAKEVISIBLE, tmpres, TAG_END] ) -> We're refreshing next
                                    ENDIF

                            ENDSELECT
                            IF tmpres <> -1 
                               IF (SetGadgetAttrsA(lbobj, win, NIL, [LISTBROWSER_SELECTED, tmpres, LISTBROWSER_MAKEVISIBLE, tmpres, TAG_END] )) THEN RefreshGList(lbobj, win, NIL, 1)
                            ENDIF

                         ENDIF

                   CASE WMHI_MENUPICK
                        IF (tmpres2 :=  Shr(code,16)) <> MENUNULL
                           itemnum := (Shr(tmpres2,5) AND $3F)

                           IF (tmpres2 AND $1F) = 0
                              SELECT itemnum
                                 CASE 0
                                    easy_r(StringF(tmpstr,'\s\n1997-98 by Eric Sauvageau\n\nThis program is Freeware.',{version_string}),'Ok')
                                 CASE 2
                                    rebuildlist()

                                 CASE 4
                                    SetAttrsA(winobj, [WA_BUSYPOINTER, TRUE, TAG_DONE])
                                    savefile()
                                    SetAttrsA(winobj, [WA_BUSYPOINTER, FALSE, TAG_DONE])
                                 CASE 6
                                    CA_CloseWindow(winobj)
                                    winsig := NIL
                                    win := NIL
                                 CASE 8
                                    done := TRUE
                              ENDSELECT
                           ENDIF
                        ENDIF

               ENDSELECT
           ENDWHILE
         ENDIF


         IF (signal AND portsig) THEN rebuildlist()

         IF (signal AND SIGBREAKF_CTRL_C) THEN done := TRUE

         IF (signal AND cxsigflag)

            WHILE (msg:=GetMsg(broker_mp))

               tmpres:=CxMsgID(msg)
               tmpres2:=CxMsgType(msg)
               ReplyMsg(msg)

               SELECT tmpres2
 
                  CASE CXM_IEVENT
                     IF tmpres = 1
               
                        IF win
                           CA_CloseWindow(winobj)
                           winsig := NIL
                           win := NIL
                        ELSE
                           win := CA_OpenWindow(winobj)
                           GetAttr( WINDOW_SIGMASK, winobj, {winsig})
                        ENDIF
                     ENDIF

                  CASE CXM_COMMAND
                     SELECT tmpres

                        CASE CXCMD_DISABLE
                           ActivateCxObj(broker, FALSE)

                        CASE CXCMD_ENABLE
                           ActivateCxObj(broker, TRUE)

                        CASE CXCMD_APPEAR
                           win := CA_OpenWindow(winobj)
                           GetAttr( WINDOW_SIGMASK, winobj, {winsig})

                        CASE CXCMD_KILL
                           done := TRUE

                        CASE CXCMD_DISAPPEAR
                           IF  win
                              CA_CloseWindow(winobj)
                              winsig := NIL
                              win := NIL
                           ENDIF

                     ENDSELECT
               ENDSELECT
            ENDWHILE
         ENDIF
      ENDWHILE

      DisposeObject(winobj)

   ENDIF

EXCEPT DO

   freeBrowserNodes(patchlist)

   IF (broker) THEN DeleteCxObjAll(broker)

   IF (broker_mp)  -> Empty the port of all CxMsgs
      WHILE (msg:=GetMsg(broker_mp)) DO ReplyMsg(msg)
      DeleteMsgPort(broker_mp)
   ENDIF
   
   IF rdargs THEN FreeArgs(rdargs)

   IF menustrip THEN FreeMenus(menustrip)
   IF visual THEN FreeVisualInfo(visual)
   IF scr THEN UnlockPubScreen(NIL,scr)

   IF (managerport) THEN deletePort(managerport)

   IF (ttypes) THEN argArrayDone()

   IF (pool) THEN libDeletePool(pool)

   CloseLibrary(gadtoolsbase)
   CloseLibrary(windowbase)
   CloseLibrary(layoutbase)
   CloseLibrary(listbrowserbase)
   CloseLibrary(utilitybase)
   CloseLibrary(cxbase)
   CloseLibrary(iconbase)

ENDPROC




PROC rebuildlist()
DEF count
   IF (SetGadgetAttrsA(lbobj, win, NIL, [LISTBROWSER_SELECTED, -1, LISTBROWSER_LABELS, -1, TAG_END] )=TRUE) AND (win<>NIL) THEN RefreshGList(lbobj, win, NIL, 1)

   freeBrowserNodes(patchlist)
   patchlist, count := buildlist()

   SetGadgetAttrsA(winobj, win, NIL, [WA_TITLE, StringF(title,'\s  -  \d patch\sfound.',{version_string},count,(IF count>1 THEN 'es ' ELSE ' ')),TAG_END])->) THEN RefreshGList(winobj, win, NIL, 1)
   RefreshWindowFrame(win)

   IF (SetGadgetAttrsA(lbobj, win, NIL, [LISTBROWSER_LABELS, patchlist, LISTBROWSER_AUTOFIT, TRUE, TAG_END] )=TRUE) AND (win<>NIL) THEN RefreshGList(lbobj, win, NIL, 1)


ENDPROC


PROC clickNode()
DEF currentnode,currentnodeptr, node:PTR TO setnode,
    address[15]:STRING, add, ievent:inputevent, relevent, relcol

   getAttrsA(lbobj,[LISTBROWSER_SELECTED, {currentnode},
                    LISTBROWSER_SELECTEDNODE, {currentnodeptr},
                    LISTBROWSER_RELEVENT, {relevent},
                    LISTBROWSER_RELCOLUMN, {relcol},
                    TAG_END])


/*** V42 beta - Header click, must sort. ***/

   IF (relevent = LBRE_TITLECLICK)

      IF (SetGadgetAttrsA(lbobj, win, NIL, [LISTBROWSER_SELECTED, -1, TAG_END] )) THEN RefreshGList(lbobj, win, NIL, 1)

      DoGadgetMethodA(lbobj, win, NIL, [LBM_SORT, NIL, relcol, (GetAttr( WINDOW_INPUTEVENT, winobj, {ievent} ) BUT (ievent.qualifier AND (IEQUALIFIER_RSHIFT OR IEQUALIFIER_LSHIFT))),NIL]:lbsort)

   ELSEIF (relevent = LBRE_DOUBLECLICK)

      IF currentnode = -1 THEN RETURN   -> Needed for keyboard handling

      GetListBrowserNodeAttrsA(currentnodeptr, [LBNA_COLUMN, 1,LBNCA_TEXT,{address},TAG_END])

      IF (add := Val(address))
         ObtainSemaphore(smport.sem)
      
         node := smport.lh.head
      
         WHILE (node.setfunc <> add) AND (node.n.succ) DO node := node.n.succ

         IF node.jmp1 = JMPCODE
            node.jmp1 := BRACODE
         ELSE
            node.jmp1 := JMPCODE
         ENDIF
         CacheClearU()

         lbEditNode(lbobj, win, NIL,currentnodeptr,[LBNA_COLUMN, 3,
                                                    LBNCA_COPYTEXT, TRUE,
                                                    LBNCA_TEXT, (IF node.jmp1 = BRACODE THEN 'Disabled' ELSE 'Active'),
                                                    TAG_END])

         ReleaseSemaphore(smport.sem)

      ENDIF
   ENDIF


ENDPROC


PROC myOpenClass(name,version, lib=FALSE)
DEF retval=NIL:PTR TO lib, buffer[256]:STRING

   IF ((retval := OpenLibrary(name, version)) = NIL) AND (lib=TRUE)
      StringF(buffer, 'SYS:Classes/\s', name)
      IF (retval := OpenLibrary(buffer, version)) = NIL
         StringF(buffer, 'Classes/\s', name)
         retval := OpenLibrary(buffer, version)
      ENDIF
   ENDIF

   IF (retval = NIL) 
      easy_r(StringF(buffer,'Can''t open "\s" V\d or better!',name,version),'Damn!')

      Raise("LIB")
   ENDIF
ENDPROC retval



PROC buildlist()
DEF node:PTR TO setnode
DEF n:PTR TO ln
DEF l=NIL:PTR TO lh
DEF libinf:PTR TO libraryinfo
DEF count=0

DEF st1[12]:STRING,
    st2[50]:STRING,
    st3:PTR TO CHAR,
    offs,
    statname:PTR TO LONG,
    functn:PTR TO CHAR


   l := NewR((SIZEOF lh))

   newList(l)

   ObtainSemaphore(smport.sem)

   node := smport.lh.head


   statname := ['Open()','Close()','Expunge()','ExtFunc()','BeginIO()','AbortIO()']

   WHILE (node.n.succ <> NIL)

      INC count

      offs := -node.offset/6
      
      IF ((offs <= 4) AND (node.lib.ln.type = NT_LIBRARY)) OR ((offs <= 6) AND (node.lib.ln.type = NT_DEVICE))
         StringF(st2,'\s - \s ',node.lib.ln.name,statname[offs-1])

      ELSEIF (libinf := findLibraryInfo(libinfolist, node.lib.ln.name))
         functn := libinf + (SIZEOF libraryinfo) + (offs*4)

         IF (offs <= libinf.entries) AND (Long(functn))
/* Using \c for the ( because of StringF() trying to interpret it */
            StringF(st2,'\s\c) ',(Long(functn)),"(")
         ENDIF
      ELSE
         StringF(st2,'\s  (-$\z\h[4]) ',node.lib.ln.name,(0-node.offset) AND $FFFF)
      ENDIF

      IF (node.setfunc = NIL)
         st3 := 'Removed'
      ELSEIF (node.jmp1 = JMPCODE)
         st3 := 'Active'
      ELSE
         st3 := 'Disabled'
      ENDIF

      IF (n := AllocListBrowserNodeA(4,[LBNA_COLUMN, 0,
                                        LBNCA_COPYTEXT, TRUE,
                                        LBNCA_TEXT, node.taskname,
                                     LBNA_COLUMN, 1,
                                        LBNCA_COPYTEXT, TRUE,
                                        LBNCA_TEXT, (IF node.setfunc THEN StringF(st1,'$\z\h[8] ',node.setfunc) ELSE '-------- '),
                                     LBNA_COLUMN, 2,
                                        LBNCA_COPYTEXT, TRUE,
                                        LBNCA_TEXT, st2,
                                     LBNA_COLUMN, 3,
                                        LBNCA_TEXT, st3,
                                     TAG_END]))
         AddTail(l, n )
      ENDIF
      node := node.n.succ
   ENDWHILE

   ReleaseSemaphore(smport.sem)

ENDPROC l, count


/*** FD file parsing ***/


PROC readAllFD(fdpath:PTR TO CHAR)
DEF libinf=NIL:PTR TO libraryinfo,
    next:PTR TO libraryinfo,
    fib:PTR TO fileinfoblock,
    dir, odir,
    proc:PTR TO process,
    winptr,
    lib=NIL:PTR TO libraryinfo


proc := FindTask(NIL)
winptr := proc.windowptr

proc.windowptr := -1

dir := Lock(fdpath,ACCESS_READ)

proc.windowptr := winptr


IF (dir)

   odir := CurrentDir(dir)

   IF (fib := AllocDosObject(DOS_FIB,NIL))
      IF (Examine(dir,fib))
         next := libinf
         
         WHILE (ExNext(dir,fib))
            IF (next := readFD(fib.filename))
               IF lib = NIL
                  lib := next
                  libinf := lib
               ELSE 
                  lib.next := next
                  lib := lib.next
               ENDIF
            ENDIF
         ENDWHILE
      ENDIF
		FreeDosObject(DOS_FIB,fib)
   ENDIF

   CurrentDir(odir)
   UnLock(dir)
ENDIF

ENDPROC libinf




PROC readFD(name:PTR TO CHAR)
DEF bptr,
    libname[35]:STRING,
    tmpstr[35]:STRING,
    lib=NIL:PTR TO libraryinfo


/* only names ending in '_lib.fd' allowed */
IF InStr(name,'_lib.fd',0)=-1 THEN RETURN NIL


   IF (bptr := Open(name,MODE_OLDFILE))

      IF (lib := processFD(bptr))

         /* Shove real name in lib */
         IF Strnicmp(name,'wb',STRLEN)=0
            StrCopy(libname,'workbench.library')
         ELSE
            StringF(libname,'\s.library',StrCopy(tmpstr,name,InStr(name,'_lib.fd')))
         ENDIF
         AstrCopy(lib.libraryname,libname,28)
      ENDIF

	   Close(bptr)
   ENDIF
ENDPROC lib




PROC processFD(handle) HANDLE
DEF entries = 0, buffer[200]:ARRAY
DEF lib=NIL:PTR TO libraryinfo
DEF offset:PTR TO LONG

DEF ptr:PTR TO CHAR

/* Count how many lines we have */
   WHILE (Fgets(handle,buffer,60) <> NIL)
      IF Strnicmp(buffer,'##bias',6)=0 THEN entries := entries + (Val(buffer+6)/6) ELSE entries++
   ENDWHILE

/* Restore pointer to start of file. */
   Seek(handle,0, OFFSET_BEGINNING)

/* +4 for safety reasons, until I can finetune it */
   IF (lib := libAllocPooled(pool,(SIZEOF libraryinfo) + (entries+4)*4))=NIL THEN Raise("MEM")

/* Re-reading it.  Since our file is small, we're relying on the 
   filesystem's buffering to avoid unnecessary disk access rather than 
   reading and parsing twice from our own buffers.  Not the fastest, but 
   surely the simplest. */

   offset := lib + (SIZEOF libraryinfo)

   WHILE (Fgets(handle,buffer,200) <> NIL)
/* Hardcoded to 60 chars - will have to make it dynamic */

      IF (buffer[0] <> "*") AND (buffer[0] <> "\n")
         IF buffer[0] = "#"
            IF Strnicmp(buffer, '##bias',6)=0
               offset := lib + (SIZEOF libraryinfo) + ((Val(buffer+7)/6)*4)
            ENDIF
         ELSE
            IF (ptr := libAllocPooled(pool,60))=NIL THEN Raise("MEM")

            offset[] := ptr
            AstrCopy(ptr, buffer, InStr(buffer,'(')+1)
            offset++
         ENDIF
      ENDIF
   ENDWHILE

   lib.entries := (offset - lib - (SIZEOF libraryinfo)) / 4
EXCEPT

ENDPROC lib


PROC findLibraryInfo(list:PTR TO libraryinfo, name:PTR TO CHAR)

   WHILE (list)
      IF Stricmp(list.libraryname,name)=0 THEN RETURN list
      list := list.next
   ENDWHILE
ENDPROC NIL



PROC savefile() HANDLE
DEF result=FALSE
DEF tmplock, handle=NIL,string[512]:STRING, file, filereqobj=NIL

  getfilebase := myOpenClass('gadgets/getfile.gadget',41,FALSE)
  filereqobj := GetFileObject, GA_RELVERIFY, TRUE, 
                               GETFILE_DOSAVEMODE, TRUE,
                            End

  IF requestFile(filereqobj, NIL) = NIL THEN Raise("ABRT")

  GetAttr(GETFILE_FULLFILE, filereqobj,{file})
  StrCopy(string,file)
           
  IF (tmplock := Lock(string,ACCESS_READ))
     UnLock(tmplock)

     result := easy_r('File already exists!','_Append|_Overwrite|_Cancel')

     SELECT result
        CASE 1 ; IF (handle := Open(string,MODE_OLDFILE))= NIL THEN Raise("FILE") ; Seek(handle,0,OFFSET_END) ; Fputs(handle,'\n\n')

        CASE 2 ; handle := Open(string,MODE_NEWFILE)
        CASE -1 ; Raise("ABRT")
     ENDSELECT
  ELSE
     handle := Open(string,MODE_NEWFILE)
  ENDIF

  IF handle = NIL THEN Raise("FILE") ELSE print(handle)

EXCEPT DO
   IF handle THEN Close(handle)
   IF filereqobj THEN DisposeObject(filereqobj)
   CloseLibrary(getfilebase)

ENDPROC


PROC print(handle) HANDLE
DEF task[30]:STRING, code[12]:STRING, function[60]:STRING, state[12]:STRING
DEF maxnode=0, nodeptr:PTR TO ln
DEF data[210]:STRING

   Fputs(handle,StringF(data,'\s by Eric Sauvageau.\n\n\nHandler Task           Code       Function                          State\n\s',{version_string},{asciiline}))

   nodeptr := patchlist.head
   WHILE nodeptr.succ <> NIL
      GetListBrowserNodeAttrsA(nodeptr, [LBNA_COLUMN, 0,LBNCA_TEXT,{task},
                                          LBNA_COLUMN, 1,LBNCA_TEXT,{code},
                                          LBNA_COLUMN, 2,LBNCA_TEXT,{function},
                                          LBNA_COLUMN, 3,LBNCA_TEXT,{state},
                                          TAG_END])

      Fputs(handle, StringF(data,'\l\s[22]\s[10] \s[35]\s[8]\n',
                                   task,   code, function, state))
      nodeptr := nodeptr.succ
      INC maxnode
   ENDWHILE

   Fputs(handle,StringF(data,'\s\d patch\s\n\n',{asciiline},maxnode,(IF maxnode > 1 THEN 'es.' ELSE '.')))

EXCEPT
ENDPROC exception



PROC easy_r(str,gad) IS EasyRequestArgs(NIL,[20,0,'SetManager',str,gad],0,NIL)

PROC setPage(page)
   SetGadgetAttrsA(lbobj, win, NIL,[LISTBROWSER_POSITION, page, TAG_DONE])
ENDPROC

CHAR '$VER: '
version_string:
CHAR 'SetManager 2.1 (21.5.98)',0

asciiline:
CHAR '----------------------------------------------------------------------------\n',0
