#include <aros/libcall.h>
#include <exec/types.h>

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

#ifndef XEmulatorSetup
#define XEmulatorSetup(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorSetup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 5, XEmulatorBase)
#endif

#ifndef XEmulatorCleanup
#define XEmulatorCleanup(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCleanup, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 8, XEmulatorBase)
#endif

#ifndef XEmulatorOpenConsole
#define XEmulatorOpenConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOpenConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 6, XEmulatorBase)
#endif

#ifndef XEmulatorCloseConsole
#define XEmulatorCloseConsole(io) \
	AROS_LC1(VOID __saveds __asm,XEmulatorCloseConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 7, XEmulatorBase)
#endif

#ifndef XEmulatorWrite
#define XEmulatorWrite(io,buff,buflen) \
	AROS_LC3(VOID __saveds __asm,XEmulatorWrite, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,buff,A1),\
	AROS_LCA(register __d0 ULONG,buflen,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 9, XEmulatorBase)
#endif

#ifndef XEmulatorSignal
#define XEmulatorSignal(io,sig) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorSignal, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,sig,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 10, XEmulatorBase)
#endif

#ifndef XEmulatorUserMon
#define XEmulatorUserMon(io,retstr,maxlen,imsg) \
	AROS_LC4(ULONG __saveds __asm,XEmulatorUserMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 UBYTE *,retstr,A1),\
	AROS_LCA(register __d0 ULONG,maxlen,D0),\
	AROS_LCA(register __a2 struct IntuiMessage *,imsg,A2),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 12, XEmulatorBase)
#endif

#ifndef XEmulatorHostMon
#define XEmulatorHostMon(io,hostData,actual) \
	AROS_LC3(ULONG __saveds __asm,XEmulatorHostMon, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorHostData *,hostData,A1),\
	AROS_LCA(register __d0 ULONG,actual,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 11, XEmulatorBase)
#endif

#ifndef XEmulatorClearConsole
#define XEmulatorClearConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorClearConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 14, XEmulatorBase)
#endif

#ifndef XEmulatorResetConsole
#define XEmulatorResetConsole(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetConsole, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 15, XEmulatorBase)
#endif

#ifndef XEmulatorResetTextStyles
#define XEmulatorResetTextStyles(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetTextStyles, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 16, XEmulatorBase)
#endif

#ifndef XEmulatorResetCharset
#define XEmulatorResetCharset(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorResetCharset, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 17, XEmulatorBase)
#endif

#ifndef XEmulatorOptions
#define XEmulatorOptions(io) \
	AROS_LC1(BOOL __saveds __asm,XEmulatorOptions, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 13, XEmulatorBase)
#endif

#ifndef XEmulatorGetFreeMacroKeys
#define XEmulatorGetFreeMacroKeys(io,qualifier) \
	AROS_LC2(ULONG __saveds __asm,XEmulatorGetFreeMacroKeys, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,qualifier,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorMacroKeyFilter
#define XEmulatorMacroKeyFilter(io,macrokeys) \
	AROS_LC2(BOOL __saveds __asm,XEmulatorMacroKeyFilter, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct XEmulatorMacroKey *,macrokeys,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 19, XEmulatorBase)
#endif

#ifndef XEmulatorInfo
#define XEmulatorInfo(io,type) \
	AROS_LC2(LONG __saveds __asm,XEmulatorInfo, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __d0 ULONG,type,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 20, XEmulatorBase)
#endif

#ifndef XEmulatorPreferences
#define XEmulatorPreferences(io,filename,mode) \
	AROS_LC3(BOOL __saveds __asm,XEmulatorPreferences, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 STRPTR,filename,A1),\
	AROS_LCA(register __d0 ULONG,mode,D0),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 21, XEmulatorBase)
#endif

#ifndef XEmulatorNewSize
#define XEmulatorNewSize(io,frame) \
	AROS_LC2(VOID __saveds __asm,XEmulatorNewSize, \
	AROS_LCA(register __a0 struct XEM_IO *,io,A0),\
	AROS_LCA(register __a1 struct IBox *,frame,A1),\
	struct XEmulatorBaseBase *, XEmulatorBaseBase, 22, XEmulatorBase)
#endif

